#!\Perl\bin\perl.exe
#
# Filename: BookMaint.cgi
# Generated with CodeCharge  1.1.20
# Perl pattern build 05/23/2001
#

use Common;
use TextTemplate;
use strict "vars";

use Header;
use Footer;

StartSession();
%cgi_params = get_form_parameters();

my $sFileName = "BookMaint.cgi";
my $sTemplateFileName = "BookMaint.html";



CheckSecurity(2);


my $sBookErr;
$dbh = DBI->connect( $strConn, $username, $password, { PrintError => 0, RaiseError => 0 } );


$oTpl->LoadTemplate( $sAppPath . $sTemplateFileName, "main" );

$oTpl->LoadTemplate( $sHeaderFileName, "Header" );
$oTpl->LoadTemplate( $sFooterFileName, "Footer" );
$oTpl->SetVar( "FileName", $sFileName );



my $sAction = GetParam("FormAction");
my $sForm = GetParam("FormName");


  if ( $sForm eq "Book" ) {
    BookAction( $sAction ) }

#Show form content

Menu_Show();
Footer_Show();
Book_Show();
$oTpl->Parse( "Header", "False" );
$oTpl->Parse( "Footer", "False" );
$oTpl->Parse( "main", "False" );

print $page_header;
print "Content-type: text/html\n\n";
print $oTpl->PrintVar("main");

exit 0;




sub BookAction {
  my $sAction = shift;

  my $sParams = "";
  my $sWhere = "";
  my $bErr = "";
  my $sSQL = "";
  my $sRes = "";

  
  my $sActionFileName = "AdminBooks.cgi";
  
  $sParams = "?";
  $sParams = $sParams . "category_id=" . ToURL(GetParam("Trn_category_id"));
  if ( $sAction eq "cancel" ) { http_redirect( $sActionFileName . $sParams  ) }
  # Create WHERE statement
  if ( $sAction eq "update" or $sAction eq "delete" ) {
    my $pPKitem_id = GetParam("PK_item_id");
    if ( ($pPKitem_id eq "")) { return 0; }
    $sWhere = "item_id=" . ToSQL($pPKitem_id, "Number");
  }

  # Load all form fields into variables

  my $fldname = GetParam("name");
  my $fldauthor = GetParam("author");
  my $fldcategory_id = GetParam("category_id");
  my $fldprice = GetParam("price");
  my $fldproduct_url = GetParam("product_url");
  my $fldimage_url = GetParam("image_url");
  my $fldnotes = GetParam("notes");
  my $fldis_recommended = getCheckBoxValue(GetParam("is_recommended"), "1", "0", "Number");
  # Validate fields
  if ( $sAction eq "insert" or $sAction eq "update" ) {
    if ( $fldname eq "" ) {
      $sBookErr = $sBookErr . "The value in field Title is required.<br>"
    }
    if ( $fldcategory_id eq "" ) {
      $sBookErr = $sBookErr . "The value in field Category is required.<br>"
    }
    if ( $fldprice eq "" ) {
      $sBookErr = $sBookErr . "The value in field Price is required.<br>"
    }
    if ( !IsNumeric($fldcategory_id) ) {
      $sBookErr = $sBookErr . "The value in field Category is incorrect.<br>"
    }
    if ( !IsNumeric($fldprice) ) {
      $sBookErr = $sBookErr . "The value in field Price is incorrect.<br>"
    }
    if ( length($sBookErr) > 0 ) {
      return 0;
    }
  }


# Create SQL statement

    if ( $sAction eq "insert" ) {      
      
      $sSQL = "insert into items (" . 
          "name," . 
          "author," . 
          "category_id," . 
          "price," . 
          "product_url," . 
          "image_url," . 
          "notes," . 
          "is_recommended)" . 
          " values (" . 
          ToSQL($fldname, "Text") . "," . 
          ToSQL($fldauthor, "Text") . "," . 
          ToSQL($fldcategory_id, "Number") . "," . 
          ToSQL($fldprice, "Number") . "," . 
          ToSQL($fldproduct_url, "Text") . "," . 
          ToSQL($fldimage_url, "Text") . "," . 
          ToSQL($fldnotes, "Text") . "," . 
          $fldis_recommended . ")"
}
      
    if ( $sAction eq "update" ) {
        $sSQL = "update items set " .
        "name=" . ToSQL($fldname, "Text") .
        ",author=" . ToSQL($fldauthor, "Text") .
        ",category_id=" . ToSQL($fldcategory_id, "Number") .
        ",price=" . ToSQL($fldprice, "Number") .
        ",product_url=" . ToSQL($fldproduct_url, "Text") .
        ",image_url=" . ToSQL($fldimage_url, "Text") .
        ",notes=" . ToSQL($fldnotes, "Text") .
        ",is_recommended=" . $fldis_recommended;
        $sSQL = $sSQL . " where " . $sWhere
    }
    
    if ( $sAction eq "delete" ) {
        $sSQL = "delete from items where " . $sWhere
    }
    
  if ( length($sBookErr) > 0 ) { return 0 }
  # Execute SQL statement
  exec_sql($sSQL);
  $sBookErr = ProceedError();
  if ( length( $sBookErr ) > 0 ) { return 0 }

  http_redirect( $sActionFileName . $sParams );
  
}


sub Book_Show {
  my $pitem_id;

  my $pitem_id;
  my $sWhere = "";
  
  my $bPK = "True";
  my $flditem_id;
  my $fldname;
  my $fldauthor;
  my $fldcategory_id;
  my $fldprice;
  my $fldproduct_url;
  my $fldimage_url;
  my $fldnotes;
  my $fldis_recommended;
  my $fldcategory_id;
  my $flditem_id;
  my $pitem_id;

  my $sOrder;

  if ( $sBookErr eq "" ) {
    # Load primary key and form parameters
    $fldcategory_id = GetParam("category_id");
    $flditem_id = GetParam("item_id");
    $oTpl->SetVar( "Trn_category_id", GetParam("category_id") );
    $pitem_id = GetParam("item_id");
    $oTpl->SetVar( "BookError", "" );
  } else {
    # Load primary key, form parameters and form fields
    $flditem_id = GetParam("item_id");
    $fldname = GetParam("name");
    $fldauthor = GetParam("author");
    $fldcategory_id = GetParam("category_id");
    $fldprice = GetParam("price");
    $fldproduct_url = GetParam("product_url");
    $fldimage_url = GetParam("image_url");
    $fldnotes = GetParam("notes");
    $fldis_recommended = GetParam("is_recommended");
    $oTpl->SetVar( "Trn_category_id", GetParam("Trn_category_id") );
    $pitem_id = GetParam("PK_item_id");
    $oTpl->SetVar( "sBookErr", $sBookErr );
    $oTpl->Parse( "BookError", "False" );
  }

  
  if ( ($pitem_id eq "")) { $bPK = ""; }
    
  $sWhere = $sWhere . "item_id=" . ToSQL($pitem_id, "Number");
  $oTpl->SetVar( "PK_item_id", $pitem_id );

  my $sSQL = "select * from items where " . $sWhere;
  my $ref_db_record;


  if ( $bPK and !($sAction eq "insert" and $sForm eq "Book") ) {
      # Open recordset
      my @db_rs = openrs($sSQL);
      $ref_db_record = $db_rs[0];
    
    $flditem_id = GetValue($ref_db_record, "item_id");
    if ( $sBookErr eq "" ) {
      # Load data from recordset when form displayed first time
      $fldname = GetValue($ref_db_record, "name");
      $fldauthor = GetValue($ref_db_record, "author");
      $fldcategory_id = GetValue($ref_db_record, "category_id");
      $fldprice = GetValue($ref_db_record, "price");
      $fldproduct_url = GetValue($ref_db_record, "product_url");
      $fldimage_url = GetValue($ref_db_record, "image_url");
      $fldnotes = GetValue($ref_db_record, "notes");
      $fldis_recommended = GetValue($ref_db_record, "is_recommended");
    }
    $oTpl->SetVar( "BookInsert", "" );
    $oTpl->Parse( "BookEdit", "False" );
  } else {
    if ( $sBookErr eq "" ) {
      $flditem_id = ToHTML(GetParam("item_id"));
      $fldcategory_id = ToHTML(GetParam("category_id"));
      $fldis_recommended= "0";
    }
    $oTpl->SetVar( "BookEdit", "" );
    $oTpl->Parse( "BookInsert", "False" );
  }
  $oTpl->Parse( "BookCancel", "False" );
  # Show form field
  
      $oTpl->SetVar( "item_id", ToHTML($flditem_id));
      $oTpl->SetVar( "name", ToHTML($fldname));
      $oTpl->SetVar( "author", ToHTML($fldauthor));
      $oTpl->SetVar( "LBcategory_id", "" );
      my @category_id = openrs_arr( "select category_id, name from categories order by 2" );
      foreach my $category_id ( @category_id ) {
        $oTpl->SetVar( "ID", $category_id->[0] );
	$oTpl->SetVar( "Value", $category_id->[1] );
        if ( GetValue($category_id, 0) eq $fldcategory_id) { $oTpl->SetVar( "Selected", "SELECTED" ) } else { $oTpl->SetVar( "Selected", "" ) }
        $oTpl->Parse( "LBcategory_id", "True" );
      }
        
      $oTpl->SetVar( "price", ToHTML($fldprice));
      $oTpl->SetVar( "product_url", ToHTML($fldproduct_url));
      $oTpl->SetVar( "image_url", ToHTML($fldimage_url));
      $oTpl->SetVar( "notes", ToHTML($fldnotes));
  if ( lc($fldis_recommended) eq lc("1") ) {
    $oTpl->SetVar( "is_recommended_CHECKED", "CHECKED" );
  } else {
    $oTpl->SetVar( "is_recommended_CHECKED", "" );
  }

  $oTpl->Parse( "FormBook", "False" );
  

}