#!\Perl\bin\perl.exe
#
# Filename: CardTypesRecord.cgi
# Generated with CodeCharge  1.1.20
# Perl pattern build 05/23/2001
#

use Common;
use TextTemplate;
use strict "vars";

use Header;
use Footer;

StartSession();
%cgi_params = get_form_parameters();

my $sFileName = "CardTypesRecord.cgi";
my $sTemplateFileName = "CardTypesRecord.html";



CheckSecurity(2);


my $sCardTypesErr;
$dbh = DBI->connect( $strConn, $username, $password, { PrintError => 0, RaiseError => 0 } );


$oTpl->LoadTemplate( $sAppPath . $sTemplateFileName, "main" );

$oTpl->LoadTemplate( $sHeaderFileName, "Header" );
$oTpl->LoadTemplate( $sFooterFileName, "Footer" );
$oTpl->SetVar( "FileName", $sFileName );



my $sAction = GetParam("FormAction");
my $sForm = GetParam("FormName");


  if ( $sForm eq "CardTypes" ) {
    CardTypesAction( $sAction ) }

#Show form content

Menu_Show();
Footer_Show();
CardTypes_Show();
$oTpl->Parse( "Header", "False" );
$oTpl->Parse( "Footer", "False" );
$oTpl->Parse( "main", "False" );

print $page_header;
print "Content-type: text/html\n\n";
print $oTpl->PrintVar("main");

exit 0;




sub CardTypesAction {
  my $sAction = shift;

  my $sParams = "";
  my $sWhere = "";
  my $bErr = "";
  my $sSQL = "";
  my $sRes = "";

  
  my $sActionFileName = "CardTypesGrid.cgi";
  
  if ( $sAction eq "cancel" ) { http_redirect( $sActionFileName ) }
  # Create WHERE statement
  if ( $sAction eq "update" or $sAction eq "delete" ) {
    my $pPKcard_type_id = GetParam("PK_card_type_id");
    if ( ($pPKcard_type_id eq "")) { return 0; }
    $sWhere = "card_type_id=" . ToSQL($pPKcard_type_id, "Number");
  }

  # Load all form fields into variables

  my $fldname = GetParam("name");
  # Validate fields
  if ( $sAction eq "insert" or $sAction eq "update" ) {
    if ( $fldname eq "" ) {
      $sCardTypesErr = $sCardTypesErr . "The value in field Name is required.<br>"
    }
    if ( length($sCardTypesErr) > 0 ) {
      return 0;
    }
  }


# Create SQL statement

    if ( $sAction eq "insert" ) {      
      
      $sSQL = "insert into card_types (" . 
          "name)" . 
          " values (" . 
          ToSQL($fldname, "Text") . ")"
}
      
    if ( $sAction eq "update" ) {
        $sSQL = "update card_types set " .
        "name=" . ToSQL($fldname, "Text");
        $sSQL = $sSQL . " where " . $sWhere
    }
    
    if ( $sAction eq "delete" ) {
        $sSQL = "delete from card_types where " . $sWhere
    }
    
  if ( length($sCardTypesErr) > 0 ) { return 0 }
  # Execute SQL statement
  exec_sql($sSQL);
  $sCardTypesErr = ProceedError();
  if ( length( $sCardTypesErr ) > 0 ) { return 0 }

  http_redirect( $sActionFileName);
  
}


sub CardTypes_Show {
  my $pcard_type_id;

  my $pcard_type_id;
  my $sWhere = "";
  
  my $bPK = "True";
  my $fldcard_type_id;
  my $fldname;
  my $fldcard_type_id;
  my $pcard_type_id;

  my $sOrder;

  if ( $sCardTypesErr eq "" ) {
    # Load primary key and form parameters
    $fldcard_type_id = GetParam("card_type_id");
    $pcard_type_id = GetParam("card_type_id");
    $oTpl->SetVar( "CardTypesError", "" );
  } else {
    # Load primary key, form parameters and form fields
    $fldcard_type_id = GetParam("card_type_id");
    $fldname = GetParam("name");
    $pcard_type_id = GetParam("PK_card_type_id");
    $oTpl->SetVar( "sCardTypesErr", $sCardTypesErr );
    $oTpl->Parse( "CardTypesError", "False" );
  }

  
  if ( ($pcard_type_id eq "")) { $bPK = ""; }
    
  $sWhere = $sWhere . "card_type_id=" . ToSQL($pcard_type_id, "Number");
  $oTpl->SetVar( "PK_card_type_id", $pcard_type_id );

  my $sSQL = "select * from card_types where " . $sWhere;
  my $ref_db_record;


  if ( $bPK and !($sAction eq "insert" and $sForm eq "CardTypes") ) {
      # Open recordset
      my @db_rs = openrs($sSQL);
      $ref_db_record = $db_rs[0];
    
    $fldcard_type_id = GetValue($ref_db_record, "card_type_id");
    if ( $sCardTypesErr eq "" ) {
      # Load data from recordset when form displayed first time
      $fldname = GetValue($ref_db_record, "name");
    }
    $oTpl->SetVar( "CardTypesInsert", "" );
    $oTpl->Parse( "CardTypesEdit", "False" );
  } else {
    if ( $sCardTypesErr eq "" ) {
      $fldcard_type_id = ToHTML(GetParam("card_type_id"));
    }
    $oTpl->SetVar( "CardTypesEdit", "" );
    $oTpl->Parse( "CardTypesInsert", "False" );
  }
  $oTpl->Parse( "CardTypesCancel", "False" );
  # Show form field
  
      $oTpl->SetVar( "card_type_id", ToHTML($fldcard_type_id));
      $oTpl->SetVar( "name", ToHTML($fldname));
  $oTpl->Parse( "FormCardTypes", "False" );
  

}