#!\Perl\bin\perl.exe
#
# Filename: CategoriesGrid.cgi
# Generated with CodeCharge  1.1.20
# Perl pattern build 05/23/2001
#

use Common;
use TextTemplate;
use strict "vars";

use Header;
use Footer;

StartSession();
%cgi_params = get_form_parameters();

my $sFileName = "CategoriesGrid.cgi";
my $sTemplateFileName = "CategoriesGrid.html";



CheckSecurity(2);


$dbh = DBI->connect( $strConn, $username, $password, { PrintError => 0, RaiseError => 0 } );


$oTpl->LoadTemplate( $sAppPath . $sTemplateFileName, "main" );

$oTpl->LoadTemplate( $sHeaderFileName, "Header" );
$oTpl->LoadTemplate( $sFooterFileName, "Footer" );
$oTpl->SetVar( "FileName", $sFileName );



#Show form content

Menu_Show();
Footer_Show();
Categories_Show();
$oTpl->Parse( "Header", "False" );
$oTpl->Parse( "Footer", "False" );
$oTpl->Parse( "main", "False" );

print $page_header;
print "Content-type: text/html\n\n";
print $oTpl->PrintVar("main");

exit 0;




sub Categories_Show {

  my ( $sOrder, $iSort, $iSorted, $sDirection, $sSortParams, $iPage );
  my $sWhere = "";
  my $HasParam = 0;
  my $sOrder = "";
  my $sSQL = "";



  $oTpl->SetVar( "TransitParams", "" );
  $oTpl->SetVar( "FormParams", "" );
# Build WHERE statement

  # Build ORDER statement
  $sOrder = " order by c.name Asc";
  $iSort = GetParam("FormCategories_Sorting");
  $iSorted = GetParam("FormCategories_Sorted");
  $sDirection = "";
  if ( $iSort eq "" ) {
    $oTpl->SetVar( "Form_Sorting", "" );
  } else {
    if ( $iSort eq $iSorted ) { 
      $oTpl->SetVar( "Form_Sorting", "" );
      $sDirection = " DESC";
      $sSortParams = "FormCategories_Sorting=" . $iSort . "&FormCategories_Sorted=" . $iSort . "&";
    } else {
      $oTpl->SetVar( "Form_Sorting", $iSort );
      $sDirection = " ASC";
      $sSortParams = "FormCategories_Sorting=" . $iSort . "&FormCategories_Sorted=" . "&"
    }
    
    if ( $iSort == 1) { $sOrder = " order by c.name" . $sDirection }
  }

  # Build full SQL statement
  
  my $sSQL = "select c.category_id as c_category_id, " . "c.name as c_name " . " from categories c ";

  $sSQL = $sSQL . $sWhere . $sOrder;
  $oTpl->SetVar( "FormAction", "CategoriesRecord.cgi" );
  $oTpl->SetVar( "SortParams", $sSortParams );
  
  # Select current page
  $iPage = GetParam("FormCategories_Page");
  if ( $iPage eq "" ) { $iPage = 1 }
  $RecordsPerPage = 20;
  # Open recordset
  my @db_rs = openrs( $sSQL, $iPage ); 
  if ( $#db_rs == -1 ) { 
  # Recordset is empty
    $oTpl->SetVar( "DListCategories", "" );
    $oTpl->Parse( "CategoriesNoRecords", "False" );
    $oTpl->SetVar( "CategoriesScroller", "" );
    $oTpl->Parse( "FormCategories", "False" );
    return 0
  }



  # Show main table based on recordset
  foreach my $ref_db_record ( @db_rs ) {
    
    my $fldname = GetValue($ref_db_record, "c_name");

      $oTpl->SetVar( "name", ToHTML($fldname) );
      $oTpl->SetVar( "name_URLLink", "CategoriesRecord.cgi");
      $oTpl->SetVar( "Prm_category_id", ToURL(GetValue($ref_db_record, "c_category_id"))); 

    $oTpl->Parse( "DListCategories", "True" );
    
  }


  # Parse scroller
  if ( $is_last_page and $iPage == 1 ) {
    $oTpl->SetVar( "CategoriesScroller", "" );
  } else {
    if ( $is_last_page ) {
      $oTpl->SetVar( "CategoriesScrollerNextSwitch", "_" );
    } else {
      $oTpl->SetVar( "NextPage", ($iPage + 1) );
      $oTpl->SetVar( "CategoriesScrollerNextSwitch", "" );
    }
    if ( $iPage == 1 ) {
      $oTpl->SetVar( "CategoriesScrollerPrevSwitch", "_" );
    } else {
      $oTpl->SetVar( "PrevPage", ($iPage - 1) );
      $oTpl->SetVar( "CategoriesScrollerPrevSwitch", "" );
    }
    $oTpl->SetVar( "CategoriesCurrentPage", $iPage );
    $oTpl->Parse( "CategoriesScroller", "False" );
  }

  $oTpl->SetVar( "CategoriesNoRecords", "" );
  $oTpl->Parse( "FormCategories", "False" );
  
}