#!\Perl\bin\perl.exe
#
# Filename: EditorialsGrid.cgi
# Generated with CodeCharge  1.1.20
# Perl pattern build 05/23/2001
#

use Common;
use TextTemplate;
use strict "vars";

use Header;
use Footer;

StartSession();
%cgi_params = get_form_parameters();

my $sFileName = "EditorialsGrid.cgi";
my $sTemplateFileName = "EditorialsGrid.html";



CheckSecurity(2);


$dbh = DBI->connect( $strConn, $username, $password, { PrintError => 0, RaiseError => 0 } );


$oTpl->LoadTemplate( $sAppPath . $sTemplateFileName, "main" );

$oTpl->LoadTemplate( $sHeaderFileName, "Header" );
$oTpl->LoadTemplate( $sFooterFileName, "Footer" );
$oTpl->SetVar( "FileName", $sFileName );



#Show form content

Menu_Show();
Footer_Show();
editorials_Show();
$oTpl->Parse( "Header", "False" );
$oTpl->Parse( "Footer", "False" );
$oTpl->Parse( "main", "False" );

print $page_header;
print "Content-type: text/html\n\n";
print $oTpl->PrintVar("main");

exit 0;




sub editorials_Show {

  my ( $sOrder, $iSort, $iSorted, $sDirection, $sSortParams, $iPage );
  my $sWhere = "";
  my $HasParam = 0;
  my $sOrder = "";
  my $sSQL = "";



  $oTpl->SetVar( "TransitParams", "" );
  $oTpl->SetVar( "FormParams", "" );
# Build WHERE statement

  # Build ORDER statement
  $sOrder = " order by e.article_title Asc";
  $iSort = GetParam("Formeditorials_Sorting");
  $iSorted = GetParam("Formeditorials_Sorted");
  $sDirection = "";
  if ( $iSort eq "" ) {
    $oTpl->SetVar( "Form_Sorting", "" );
  } else {
    if ( $iSort eq $iSorted ) { 
      $oTpl->SetVar( "Form_Sorting", "" );
      $sDirection = " DESC";
      $sSortParams = "Formeditorials_Sorting=" . $iSort . "&Formeditorials_Sorted=" . $iSort . "&";
    } else {
      $oTpl->SetVar( "Form_Sorting", $iSort );
      $sDirection = " ASC";
      $sSortParams = "Formeditorials_Sorting=" . $iSort . "&Formeditorials_Sorted=" . "&"
    }
    
    if ( $iSort == 1) { $sOrder = " order by e.article_title" . $sDirection }
    if ( $iSort == 2) { $sOrder = " order by e1.editorial_cat_name" . $sDirection }
    if ( $iSort == 3) { $sOrder = " order by i.name" . $sDirection }
  }

  # Build full SQL statement
  
  my $sSQL = "select e.article_id as e_article_id, " . "e.article_title as e_article_title, " . "e.editorial_cat_id as e_editorial_cat_id, " . "e.item_id as e_item_id, " . "e1.editorial_cat_id as e1_editorial_cat_id, " . "e1.editorial_cat_name as e1_editorial_cat_name, " . "i.item_id as i_item_id, " . "i.name as i_name " . " from editorials e, editorial_categories as e1, items as i" . " where e1.editorial_cat_id=e.editorial_cat_id and i.item_id=e.item_id  ";

  $sSQL = $sSQL . $sWhere . $sOrder;
  $oTpl->SetVar( "FormAction", "EditorialsRecord.cgi" );
  $oTpl->SetVar( "SortParams", $sSortParams );
  
  # Select current page
  $iPage = GetParam("Formeditorials_Page");
  if ( $iPage eq "" ) { $iPage = 1 }
  $RecordsPerPage = 20;
  # Open recordset
  my @db_rs = openrs( $sSQL, $iPage ); 
  if ( $#db_rs == -1 ) { 
  # Recordset is empty
    $oTpl->SetVar( "DListeditorials", "" );
    $oTpl->Parse( "editorialsNoRecords", "False" );
    $oTpl->SetVar( "editorialsScroller", "" );
    $oTpl->Parse( "Formeditorials", "False" );
    return 0
  }



  # Show main table based on recordset
  foreach my $ref_db_record ( @db_rs ) {
    
    my $fldarticle_id = GetValue($ref_db_record, "e_article_id");
    my $fldarticle_title = GetValue($ref_db_record, "e_article_title");
    my $fldeditorial_cat_id = GetValue($ref_db_record, "e1_editorial_cat_name");
    my $flditem_id = GetValue($ref_db_record, "i_name");

      $oTpl->SetVar( "article_id", ToHTML($fldarticle_id));
      $oTpl->SetVar( "article_title", ToHTML($fldarticle_title) );
      $oTpl->SetVar( "article_title_URLLink", "EditorialsRecord.cgi");
      $oTpl->SetVar( "Prm_article_id", ToURL(GetValue($ref_db_record, "e_article_id"))); 
      $oTpl->SetVar( "editorial_cat_id", ToHTML($fldeditorial_cat_id));
      $oTpl->SetVar( "item_id", ToHTML($flditem_id));

    $oTpl->Parse( "DListeditorials", "True" );
    
  }


  # Parse scroller
  if ( $is_last_page and $iPage == 1 ) {
    $oTpl->SetVar( "editorialsScroller", "" );
  } else {
    if ( $is_last_page ) {
      $oTpl->SetVar( "editorialsScrollerNextSwitch", "_" );
    } else {
      $oTpl->SetVar( "NextPage", ($iPage + 1) );
      $oTpl->SetVar( "editorialsScrollerNextSwitch", "" );
    }
    if ( $iPage == 1 ) {
      $oTpl->SetVar( "editorialsScrollerPrevSwitch", "_" );
    } else {
      $oTpl->SetVar( "PrevPage", ($iPage - 1) );
      $oTpl->SetVar( "editorialsScrollerPrevSwitch", "" );
    }
    $oTpl->SetVar( "editorialsCurrentPage", $iPage );
    $oTpl->Parse( "editorialsScroller", "False" );
  }

  $oTpl->SetVar( "editorialsNoRecords", "" );
  $oTpl->Parse( "Formeditorials", "False" );
  
}