#!\Perl\bin\perl.exe
#
# Filename: EditorialsRecord.cgi
# Generated with CodeCharge  1.1.20
# Perl pattern build 05/23/2001
#

use Common;
use TextTemplate;
use strict "vars";

use Header;
use Footer;

StartSession();
%cgi_params = get_form_parameters();

my $sFileName = "EditorialsRecord.cgi";
my $sTemplateFileName = "EditorialsRecord.html";



CheckSecurity(2);


my $seditorialsErr;
$dbh = DBI->connect( $strConn, $username, $password, { PrintError => 0, RaiseError => 0 } );


$oTpl->LoadTemplate( $sAppPath . $sTemplateFileName, "main" );

$oTpl->LoadTemplate( $sHeaderFileName, "Header" );
$oTpl->LoadTemplate( $sFooterFileName, "Footer" );
$oTpl->SetVar( "FileName", $sFileName );



my $sAction = GetParam("FormAction");
my $sForm = GetParam("FormName");


  if ( $sForm eq "editorials" ) {
    editorialsAction( $sAction ) }

#Show form content

Menu_Show();
Footer_Show();
editorials_Show();
$oTpl->Parse( "Header", "False" );
$oTpl->Parse( "Footer", "False" );
$oTpl->Parse( "main", "False" );

print $page_header;
print "Content-type: text/html\n\n";
print $oTpl->PrintVar("main");

exit 0;




sub editorialsAction {
  my $sAction = shift;

  my $sParams = "";
  my $sWhere = "";
  my $bErr = "";
  my $sSQL = "";
  my $sRes = "";

  
  my $sActionFileName = "EditorialsGrid.cgi";
  
  if ( $sAction eq "cancel" ) { http_redirect( $sActionFileName ) }
  # Create WHERE statement
  if ( $sAction eq "update" or $sAction eq "delete" ) {
    my $pPKarticle_id = GetParam("PK_article_id");
    if ( ($pPKarticle_id eq "")) { return 0; }
    $sWhere = "article_id=" . ToSQL($pPKarticle_id, "Number");
  }

  # Load all form fields into variables

  my $fldarticle_desc = GetParam("article_desc");
  my $fldarticle_title = GetParam("article_title");
  my $fldeditorial_cat_id = GetParam("editorial_cat_id");
  my $flditem_id = GetParam("item_id");
  # Validate fields
  if ( $sAction eq "insert" or $sAction eq "update" ) {
    if ( $fldeditorial_cat_id eq "" ) {
      $seditorialsErr = $seditorialsErr . "The value in field Editorial Category is required.<br>"
    }
    if ( !IsNumeric($fldeditorial_cat_id) ) {
      $seditorialsErr = $seditorialsErr . "The value in field Editorial Category is incorrect.<br>"
    }
    if ( !IsNumeric($flditem_id) ) {
      $seditorialsErr = $seditorialsErr . "The value in field Item is incorrect.<br>"
    }
    if ( length($seditorialsErr) > 0 ) {
      return 0;
    }
  }


# Create SQL statement

    if ( $sAction eq "insert" ) {      
      
      $sSQL = "insert into editorials (" . 
          "article_desc," . 
          "article_title," . 
          "editorial_cat_id," . 
          "item_id)" . 
          " values (" . 
          ToSQL($fldarticle_desc, "Text") . "," . 
          ToSQL($fldarticle_title, "Text") . "," . 
          ToSQL($fldeditorial_cat_id, "Number") . "," . 
          ToSQL($flditem_id, "Number") . ")"
}
      
    if ( $sAction eq "update" ) {
        $sSQL = "update editorials set " .
        "article_desc=" . ToSQL($fldarticle_desc, "Text") .
        ",article_title=" . ToSQL($fldarticle_title, "Text") .
        ",editorial_cat_id=" . ToSQL($fldeditorial_cat_id, "Number") .
        ",item_id=" . ToSQL($flditem_id, "Number");
        $sSQL = $sSQL . " where " . $sWhere
    }
    
    if ( $sAction eq "delete" ) {
        $sSQL = "delete from editorials where " . $sWhere
    }
    
  if ( length($seditorialsErr) > 0 ) { return 0 }
  # Execute SQL statement
  exec_sql($sSQL);
  $seditorialsErr = ProceedError();
  if ( length( $seditorialsErr ) > 0 ) { return 0 }

  http_redirect( $sActionFileName);
  
}


sub editorials_Show {
  my $particle_id;

  my $particle_id;
  my $sWhere = "";
  
  my $bPK = "True";
  my $fldarticle_id;
  my $fldarticle_desc;
  my $fldarticle_title;
  my $fldeditorial_cat_id;
  my $flditem_id;
  my $fldarticle_id;
  my $particle_id;

  my $sOrder;

  if ( $seditorialsErr eq "" ) {
    # Load primary key and form parameters
    $fldarticle_id = GetParam("article_id");
    $particle_id = GetParam("article_id");
    $oTpl->SetVar( "editorialsError", "" );
  } else {
    # Load primary key, form parameters and form fields
    $fldarticle_id = GetParam("article_id");
    $fldarticle_desc = GetParam("article_desc");
    $fldarticle_title = GetParam("article_title");
    $fldeditorial_cat_id = GetParam("editorial_cat_id");
    $flditem_id = GetParam("item_id");
    $particle_id = GetParam("PK_article_id");
    $oTpl->SetVar( "seditorialsErr", $seditorialsErr );
    $oTpl->Parse( "editorialsError", "False" );
  }

  
  if ( ($particle_id eq "")) { $bPK = ""; }
    
  $sWhere = $sWhere . "article_id=" . ToSQL($particle_id, "Number");
  $oTpl->SetVar( "PK_article_id", $particle_id );

  my $sSQL = "select * from editorials where " . $sWhere;
  my $ref_db_record;


  if ( $bPK and !($sAction eq "insert" and $sForm eq "editorials") ) {
      # Open recordset
      my @db_rs = openrs($sSQL);
      $ref_db_record = $db_rs[0];
    
    $fldarticle_id = GetValue($ref_db_record, "article_id");
    if ( $seditorialsErr eq "" ) {
      # Load data from recordset when form displayed first time
      $fldarticle_desc = GetValue($ref_db_record, "article_desc");
      $fldarticle_title = GetValue($ref_db_record, "article_title");
      $fldeditorial_cat_id = GetValue($ref_db_record, "editorial_cat_id");
      $flditem_id = GetValue($ref_db_record, "item_id");
    }
    $oTpl->SetVar( "editorialsInsert", "" );
    $oTpl->Parse( "editorialsEdit", "False" );
  } else {
    if ( $seditorialsErr eq "" ) {
      $fldarticle_id = ToHTML(GetParam("article_id"));
    }
    $oTpl->SetVar( "editorialsEdit", "" );
    $oTpl->Parse( "editorialsInsert", "False" );
  }
  $oTpl->Parse( "editorialsCancel", "False" );
  # Show form field
  
      $oTpl->SetVar( "article_id", ToHTML($fldarticle_id));
      $oTpl->SetVar( "article_desc", ToHTML($fldarticle_desc));
      $oTpl->SetVar( "article_title", ToHTML($fldarticle_title));
      $oTpl->SetVar( "LBeditorial_cat_id", "" );
      my @editorial_cat_id = openrs_arr( "select editorial_cat_id, editorial_cat_name from editorial_categories order by 2" );
      foreach my $editorial_cat_id ( @editorial_cat_id ) {
        $oTpl->SetVar( "ID", $editorial_cat_id->[0] );
	$oTpl->SetVar( "Value", $editorial_cat_id->[1] );
        if ( GetValue($editorial_cat_id, 0) eq $fldeditorial_cat_id) { $oTpl->SetVar( "Selected", "SELECTED" ) } else { $oTpl->SetVar( "Selected", "" ) }
        $oTpl->Parse( "LBeditorial_cat_id", "True" );
      }
        
      $oTpl->SetVar( "LBitem_id", "" );
      $oTpl->SetVar( "ID", "" );
      $oTpl->SetVar( "Value", "" );
      $oTpl->Parse( "LBitem_id", "True" );
      my @item_id = openrs_arr( "select item_id, name from items order by 2" );
      foreach my $item_id ( @item_id ) {
        $oTpl->SetVar( "ID", $item_id->[0] );
	$oTpl->SetVar( "Value", $item_id->[1] );
        if ( GetValue($item_id, 0) eq $flditem_id) { $oTpl->SetVar( "Selected", "SELECTED" ) } else { $oTpl->SetVar( "Selected", "" ) }
        $oTpl->Parse( "LBitem_id", "True" );
      }
        
  $oTpl->Parse( "Formeditorials", "False" );
  

}