#!\Perl\bin\perl.exe
#
# Filename: MembersGrid.cgi
# Generated with CodeCharge  1.1.20
# Perl pattern build 05/23/2001
#

use Common;
use TextTemplate;
use strict "vars";

use Header;
use Footer;

StartSession();
%cgi_params = get_form_parameters();

my $sFileName = "MembersGrid.cgi";
my $sTemplateFileName = "MembersGrid.html";



CheckSecurity(2);


$dbh = DBI->connect( $strConn, $username, $password, { PrintError => 0, RaiseError => 0 } );


$oTpl->LoadTemplate( $sAppPath . $sTemplateFileName, "main" );

$oTpl->LoadTemplate( $sHeaderFileName, "Header" );
$oTpl->LoadTemplate( $sFooterFileName, "Footer" );
$oTpl->SetVar( "FileName", $sFileName );



#Show form content

Menu_Show();
Footer_Show();
Search_Show();
Members_Show();
$oTpl->Parse( "Header", "False" );
$oTpl->Parse( "Footer", "False" );
$oTpl->Parse( "main", "False" );

print $page_header;
print "Content-type: text/html\n\n";
print $oTpl->PrintVar("main");

exit 0;




sub Search_Show {
  
  $oTpl->SetVar( "ActionPage", "MembersGrid.cgi" );

  # Set variables with search parameters
  
  my $fldname = GetParam("name");
  # Show fields
  

      $oTpl->SetVar( "name", ToHTML($fldname));
  $oTpl->Parse( "FormSearch", "False" );
}



sub Members_Show {

  my ( $sOrder, $iSort, $iSorted, $sDirection, $sSortParams, $iPage );
  my $sWhere = "";
  my $HasParam = 0;
  my $sOrder = "";
  my $sSQL = "";



  $oTpl->SetVar( "TransitParams", "name=" . ToURL(GetParam("name")) . "&" );
  $oTpl->SetVar( "FormParams", "name=" . ToURL(GetParam("name")) . "&");
# Build WHERE statement
# Check Members parameter and create a valid sql for where clause
  
  my $pname = GetParam("name");
  if ($pname ne "") {
   	$HasParam = 1;
    $sWhere = "m.member_login like '%" . replace($pname, "'", "''") . "%'" . " or " . "m.first_name like '%" . replace($pname, "'", "''") . "%'" . " or " . "m.last_name like '%" . replace($pname, "'", "''") . "%'"
  }

  if ( $HasParam ) { $sWhere = " WHERE (" . $sWhere . ")" }
  # Build ORDER statement
  $sOrder = " order by m.member_login Asc";
  $iSort = GetParam("FormMembers_Sorting");
  $iSorted = GetParam("FormMembers_Sorted");
  $sDirection = "";
  if ( $iSort eq "" ) {
    $oTpl->SetVar( "Form_Sorting", "" );
  } else {
    if ( $iSort eq $iSorted ) { 
      $oTpl->SetVar( "Form_Sorting", "" );
      $sDirection = " DESC";
      $sSortParams = "FormMembers_Sorting=" . $iSort . "&FormMembers_Sorted=" . $iSort . "&";
    } else {
      $oTpl->SetVar( "Form_Sorting", $iSort );
      $sDirection = " ASC";
      $sSortParams = "FormMembers_Sorting=" . $iSort . "&FormMembers_Sorted=" . "&"
    }
    
    if ( $iSort == 1) { $sOrder = " order by m.member_login" . $sDirection }
    if ( $iSort == 2) { $sOrder = " order by m.first_name" . $sDirection }
    if ( $iSort == 3) { $sOrder = " order by m.last_name" . $sDirection }
    if ( $iSort == 4) { $sOrder = " order by m.member_level" . $sDirection }
  }

  # Build full SQL statement
  
  my $sSQL = "select m.first_name as m_first_name, " . "m.last_name as m_last_name, " . "m.member_id as m_member_id, " . "m.member_level as m_member_level, " . "m.member_login as m_member_login " . " from members m ";

  $sSQL = $sSQL . $sWhere . $sOrder;
  $oTpl->SetVar( "FormAction", "MembersRecord.cgi" );
  $oTpl->SetVar( "SortParams", $sSortParams );
  
  # Select current page
  $iPage = GetParam("FormMembers_Page");
  if ( $iPage eq "" ) { $iPage = 1 }
  $RecordsPerPage = 20;
  # Open recordset
  my @db_rs = openrs( $sSQL, $iPage ); 
  if ( $#db_rs == -1 ) { 
  # Recordset is empty
    $oTpl->SetVar( "DListMembers", "" );
    $oTpl->Parse( "MembersNoRecords", "False" );
    $oTpl->SetVar( "MembersScroller", "" );
    $oTpl->Parse( "FormMembers", "False" );
    return 0
  }


  my @amember_level = split /;/, "1;Member;2;Administrator";

  # Show main table based on recordset
  foreach my $ref_db_record ( @db_rs ) {
    
    my $fldmember_login = GetValue($ref_db_record, "m_member_login");
    my $fldname = GetValue($ref_db_record, "m_first_name");
    my $fldlast_name = GetValue($ref_db_record, "m_last_name");
    my $fldmember_level = GetValue($ref_db_record, "m_member_level");

      $oTpl->SetVar( "member_login", ToHTML($fldmember_login) );
      $oTpl->SetVar( "member_login_URLLink", "MembersInfo.cgi");
      $oTpl->SetVar( "Prm_member_id", ToURL(GetValue($ref_db_record, "m_member_id"))); 
      $oTpl->SetVar( "name", ToHTML($fldname));
      $oTpl->SetVar( "last_name", ToHTML($fldlast_name));
      $fldmember_level = getValFromLOV($fldmember_level, @amember_level);
      $oTpl->SetVar( "member_level", ToHTML($fldmember_level));

    $oTpl->Parse( "DListMembers", "True" );
    
  }


  # Parse scroller
  if ( $is_last_page and $iPage == 1 ) {
    $oTpl->SetVar( "MembersScroller", "" );
  } else {
    if ( $is_last_page ) {
      $oTpl->SetVar( "MembersScrollerNextSwitch", "_" );
    } else {
      $oTpl->SetVar( "NextPage", ($iPage + 1) );
      $oTpl->SetVar( "MembersScrollerNextSwitch", "" );
    }
    if ( $iPage == 1 ) {
      $oTpl->SetVar( "MembersScrollerPrevSwitch", "_" );
    } else {
      $oTpl->SetVar( "PrevPage", ($iPage - 1) );
      $oTpl->SetVar( "MembersScrollerPrevSwitch", "" );
    }
    $oTpl->SetVar( "MembersCurrentPage", $iPage );
    $oTpl->Parse( "MembersScroller", "False" );
  }

  $oTpl->SetVar( "MembersNoRecords", "" );
  $oTpl->Parse( "FormMembers", "False" );
  
}