#!\Perl\bin\perl.exe
#
# Filename: MembersRecord.cgi
# Generated with CodeCharge  1.1.20
# Perl pattern build 05/23/2001
#

use Common;
use TextTemplate;
use strict "vars";

use Header;
use Footer;

StartSession();
%cgi_params = get_form_parameters();

my $sFileName = "MembersRecord.cgi";
my $sTemplateFileName = "MembersRecord.html";



CheckSecurity(2);


my $sMembersErr;
$dbh = DBI->connect( $strConn, $username, $password, { PrintError => 0, RaiseError => 0 } );


$oTpl->LoadTemplate( $sAppPath . $sTemplateFileName, "main" );

$oTpl->LoadTemplate( $sHeaderFileName, "Header" );
$oTpl->LoadTemplate( $sFooterFileName, "Footer" );
$oTpl->SetVar( "FileName", $sFileName );



my $sAction = GetParam("FormAction");
my $sForm = GetParam("FormName");


  if ( $sForm eq "Members" ) {
    MembersAction( $sAction ) }

#Show form content

Menu_Show();
Footer_Show();
Members_Show();
$oTpl->Parse( "Header", "False" );
$oTpl->Parse( "Footer", "False" );
$oTpl->Parse( "main", "False" );

print $page_header;
print "Content-type: text/html\n\n";
print $oTpl->PrintVar("main");

exit 0;




sub MembersAction {
  my $sAction = shift;

  my $sParams = "";
  my $sWhere = "";
  my $bErr = "";
  my $sSQL = "";
  my $sRes = "";

  
  my $sActionFileName = "MembersGrid.cgi";
  
  $sParams = "?";
  $sParams = $sParams . "member_login=" . ToURL(GetParam("Trn_member_login"));
  if ( $sAction eq "cancel" ) { http_redirect( $sActionFileName . $sParams  ) }
  # Create WHERE statement
  if ( $sAction eq "update" or $sAction eq "delete" ) {
    my $pPKmember_id = GetParam("PK_member_id");
    if ( ($pPKmember_id eq "")) { return 0; }
    $sWhere = "member_id=" . ToSQL($pPKmember_id, "Number");
  }

  # Load all form fields into variables

  my $fldmember_login = GetParam("member_login");
  my $fldmember_password = GetParam("member_password");
  my $fldmember_level = GetParam("member_level");
  my $fldname = GetParam("name");
  my $fldlast_name = GetParam("last_name");
  my $fldemail = GetParam("email");
  my $fldphone = GetParam("phone");
  my $fldaddress = GetParam("address");
  my $fldnotes = GetParam("notes");
  my $fldcard_type_id = GetParam("card_type_id");
  my $fldcard_number = GetParam("card_number");
  # Validate fields
  if ( $sAction eq "insert" or $sAction eq "update" ) {
    if ( $fldmember_login eq "" ) {
      $sMembersErr = $sMembersErr . "The value in field Login* is required.<br>"
    }
    if ( $fldmember_password eq "" ) {
      $sMembersErr = $sMembersErr . "The value in field Password* is required.<br>"
    }
    if ( $fldmember_level eq "" ) {
      $sMembersErr = $sMembersErr . "The value in field Level* is required.<br>"
    }
    if ( $fldname eq "" ) {
      $sMembersErr = $sMembersErr . "The value in field First Name* is required.<br>"
    }
    if ( $fldlast_name eq "" ) {
      $sMembersErr = $sMembersErr . "The value in field Last Name* is required.<br>"
    }
    if ( $fldemail eq "" ) {
      $sMembersErr = $sMembersErr . "The value in field Email* is required.<br>"
    }
    if ( !IsNumeric($fldmember_level) ) {
      $sMembersErr = $sMembersErr . "The value in field Level* is incorrect.<br>"
    }
    if ( !IsNumeric($fldcard_type_id) ) {
      $sMembersErr = $sMembersErr . "The value in field Credit Card Type is incorrect.<br>"
    }
    if ( $fldmember_login ne ""  ) {
      my $iCount = 0;
      if ( $sAction eq "insert" ) {
        $iCount = DLookUp("members", "count(*)", "member_login=" . ToSQL($fldmember_login, "Text"));
      } elsif ( $sAction eq "update" ) {
        $iCount = DLookUp("members", "count(*)", "member_login=" . ToSQL($fldmember_login, "Text") . " and not(" . $sWhere . ")");
      }
      if ( $iCount > 0 ) {
        $sMembersErr = $sMembersErr . "The value in field Login* is already in database.<br>";
      }
    }
    if ( length($sMembersErr) > 0 ) {
      return 0;
    }
  }


# Create SQL statement

    if ( $sAction eq "insert" ) {      
      
      $sSQL = "insert into members (" . 
          "member_login," . 
          "member_password," . 
          "member_level," . 
          "first_name," . 
          "last_name," . 
          "email," . 
          "phone," . 
          "address," . 
          "notes," . 
          "card_type_id," . 
          "card_number)" . 
          " values (" . 
          ToSQL($fldmember_login, "Text") . "," . 
          ToSQL($fldmember_password, "Text") . "," . 
          ToSQL($fldmember_level, "Number") . "," . 
          ToSQL($fldname, "Text") . "," . 
          ToSQL($fldlast_name, "Text") . "," . 
          ToSQL($fldemail, "Text") . "," . 
          ToSQL($fldphone, "Text") . "," . 
          ToSQL($fldaddress, "Text") . "," . 
          ToSQL($fldnotes, "Text") . "," . 
          ToSQL($fldcard_type_id, "Number") . "," . 
          ToSQL($fldcard_number, "Text") . ")"
}
      
    if ( $sAction eq "update" ) {
        $sSQL = "update members set " .
        "member_login=" . ToSQL($fldmember_login, "Text") .
        ",member_password=" . ToSQL($fldmember_password, "Text") .
        ",member_level=" . ToSQL($fldmember_level, "Number") .
        ",first_name=" . ToSQL($fldname, "Text") .
        ",last_name=" . ToSQL($fldlast_name, "Text") .
        ",email=" . ToSQL($fldemail, "Text") .
        ",phone=" . ToSQL($fldphone, "Text") .
        ",address=" . ToSQL($fldaddress, "Text") .
        ",notes=" . ToSQL($fldnotes, "Text") .
        ",card_type_id=" . ToSQL($fldcard_type_id, "Number") .
        ",card_number=" . ToSQL($fldcard_number, "Text");
        $sSQL = $sSQL . " where " . $sWhere
    }
    
    if ( $sAction eq "delete" ) {
        $sSQL = "delete from members where " . $sWhere
    }
    
  if ( length($sMembersErr) > 0 ) { return 0 }
  # Execute SQL statement
  exec_sql($sSQL);
  $sMembersErr = ProceedError();
  if ( length( $sMembersErr ) > 0 ) { return 0 }

  http_redirect( $sActionFileName . $sParams );
  
}


sub Members_Show {
  my $pmember_id;

  my $pmember_id;
  my $sWhere = "";
  
  my $bPK = "True";
  my $fldmember_id;
  my $fldmember_login;
  my $fldmember_password;
  my $fldmember_level;
  my $fldname;
  my $fldlast_name;
  my $fldemail;
  my $fldphone;
  my $fldaddress;
  my $fldnotes;
  my $fldcard_type_id;
  my $fldcard_number;
  my $fldmember_login;
  my $fldmember_id;
  my $pmember_id;

  my $sOrder;

  if ( $sMembersErr eq "" ) {
    # Load primary key and form parameters
    $fldmember_login = GetParam("member_login");
    $fldmember_id = GetParam("member_id");
    $oTpl->SetVar( "Trn_member_login", GetParam("member_login") );
    $pmember_id = GetParam("member_id");
    $oTpl->SetVar( "MembersError", "" );
  } else {
    # Load primary key, form parameters and form fields
    $fldmember_id = GetParam("member_id");
    $fldmember_login = GetParam("member_login");
    $fldmember_password = GetParam("member_password");
    $fldmember_level = GetParam("member_level");
    $fldname = GetParam("name");
    $fldlast_name = GetParam("last_name");
    $fldemail = GetParam("email");
    $fldphone = GetParam("phone");
    $fldaddress = GetParam("address");
    $fldnotes = GetParam("notes");
    $fldcard_type_id = GetParam("card_type_id");
    $fldcard_number = GetParam("card_number");
    $oTpl->SetVar( "Trn_member_login", GetParam("Trn_member_login") );
    $pmember_id = GetParam("PK_member_id");
    $oTpl->SetVar( "sMembersErr", $sMembersErr );
    $oTpl->Parse( "MembersError", "False" );
  }

  
  if ( ($pmember_id eq "")) { $bPK = ""; }
    
  $sWhere = $sWhere . "member_id=" . ToSQL($pmember_id, "Number");
  $oTpl->SetVar( "PK_member_id", $pmember_id );

  my $sSQL = "select * from members where " . $sWhere;
  my $ref_db_record;


  if ( $bPK and !($sAction eq "insert" and $sForm eq "Members") ) {
      # Open recordset
      my @db_rs = openrs($sSQL);
      $ref_db_record = $db_rs[0];
    
    $fldmember_id = GetValue($ref_db_record, "member_id");
    if ( $sMembersErr eq "" ) {
      # Load data from recordset when form displayed first time
      $fldmember_login = GetValue($ref_db_record, "member_login");
      $fldmember_password = GetValue($ref_db_record, "member_password");
      $fldmember_level = GetValue($ref_db_record, "member_level");
      $fldname = GetValue($ref_db_record, "first_name");
      $fldlast_name = GetValue($ref_db_record, "last_name");
      $fldemail = GetValue($ref_db_record, "email");
      $fldphone = GetValue($ref_db_record, "phone");
      $fldaddress = GetValue($ref_db_record, "address");
      $fldnotes = GetValue($ref_db_record, "notes");
      $fldcard_type_id = GetValue($ref_db_record, "card_type_id");
      $fldcard_number = GetValue($ref_db_record, "card_number");
    }
    $oTpl->SetVar( "MembersInsert", "" );
    $oTpl->Parse( "MembersEdit", "False" );
  } else {
    if ( $sMembersErr eq "" ) {
      $fldmember_id = ToHTML(GetParam("member_id"));
      $fldmember_login = ToHTML(GetParam("member_login"));
    }
    $oTpl->SetVar( "MembersEdit", "" );
    $oTpl->Parse( "MembersInsert", "False" );
  }
  $oTpl->Parse( "MembersCancel", "False" );
  # Show form field
  
      $oTpl->SetVar( "member_id", ToHTML($fldmember_id));
      $oTpl->SetVar( "member_login", ToHTML($fldmember_login));
      $oTpl->SetVar( "member_password", ToHTML($fldmember_password));
      $oTpl->SetVar( "LBmember_level", "" );
      my @LOV = split( /;/, "1;Member;2;Administrator");
      if ( ($#LOV % 2) == 1 ) {
        for ( my $i = 0; $i <= $#LOV; $i+=2 ) {
          $oTpl->SetVar( "ID", $LOV[$i] );
	  $oTpl->SetVar( "Value", $LOV[$i+1] );
          if ( $LOV[$i] eq $fldmember_level ) { 
	    $oTpl->SetVar( "Selected", "SELECTED" ) 
	  } else { 
	    $oTpl->SetVar( "Selected", "" )
	  }
          $oTpl->Parse( "LBmember_level", "True" );
        }
      }
  
      $oTpl->SetVar( "name", ToHTML($fldname));
      $oTpl->SetVar( "last_name", ToHTML($fldlast_name));
      $oTpl->SetVar( "email", ToHTML($fldemail));
      $oTpl->SetVar( "phone", ToHTML($fldphone));
      $oTpl->SetVar( "address", ToHTML($fldaddress));
      $oTpl->SetVar( "notes", ToHTML($fldnotes));
      $oTpl->SetVar( "LBcard_type_id", "" );
      $oTpl->SetVar( "ID", "" );
      $oTpl->SetVar( "Value", "" );
      $oTpl->Parse( "LBcard_type_id", "True" );
      my @card_type_id = openrs_arr( "select card_type_id, name from card_types order by 2" );
      foreach my $card_type_id ( @card_type_id ) {
        $oTpl->SetVar( "ID", $card_type_id->[0] );
	$oTpl->SetVar( "Value", $card_type_id->[1] );
        if ( GetValue($card_type_id, 0) eq $fldcard_type_id) { $oTpl->SetVar( "Selected", "SELECTED" ) } else { $oTpl->SetVar( "Selected", "" ) }
        $oTpl->Parse( "LBcard_type_id", "True" );
      }
        
      $oTpl->SetVar( "card_number", ToHTML($fldcard_number));
  $oTpl->Parse( "FormMembers", "False" );
  

}