#!\Perl\bin\perl.exe
#
# Filename: AdminBooks.cgi
# Generated with CodeCharge  1.1.20
# Perl pattern build 05/23/2001
#

use Common;
use TextTemplate;
use strict "vars";

use Header;
use Footer;

StartSession();
%cgi_params = get_form_parameters();

my $sFileName = "AdminBooks.cgi";
my $sTemplateFileName = "AdminBooks.html";



CheckSecurity(2);


$dbh = DBI->connect( $strConn, $username, $password, { PrintError => 0, RaiseError => 0 } );


$oTpl->LoadTemplate( $sAppPath . $sTemplateFileName, "main" );

$oTpl->LoadTemplate( $sHeaderFileName, "Header" );
$oTpl->LoadTemplate( $sFooterFileName, "Footer" );
$oTpl->SetVar( "FileName", $sFileName );



#Show form content

Menu_Show();
Footer_Show();
Search_Show();
Items_Show();
$oTpl->Parse( "Header", "False" );
$oTpl->Parse( "Footer", "False" );
$oTpl->Parse( "main", "False" );

print $page_header;
print "Content-type: text/html\n\n";
print $oTpl->PrintVar("main");

exit 0;




sub Search_Show {
  
  $oTpl->SetVar( "ActionPage", "AdminBooks.cgi" );

  # Set variables with search parameters
  
  my $fldcategory_id = GetParam("category_id");
  my $fldis_recommended = GetParam("is_recommended");
  # Show fields
  

      $oTpl->SetVar( "LBcategory_id", "" );
      $oTpl->SetVar( "ID", "" );
      $oTpl->SetVar( "Value", "All" );
      $oTpl->Parse( "LBcategory_id", "True" );
      my @category_id = openrs_arr( "select category_id, name from categories order by 2" );
      foreach my $category_id ( @category_id ) {
        $oTpl->SetVar( "ID", $category_id->[0] );
	$oTpl->SetVar( "Value", $category_id->[1] );
        if ( GetValue($category_id, 0) eq $fldcategory_id) { $oTpl->SetVar( "Selected", "SELECTED" ) } else { $oTpl->SetVar( "Selected", "" ) }
        $oTpl->Parse( "LBcategory_id", "True" );
      }
        
      $oTpl->SetVar( "LBis_recommended", "" );
      my @LOV = split( /;/, ";All;0;No;1;Yes");
      if ( ($#LOV % 2) == 1 ) {
        for ( my $i = 0; $i <= $#LOV; $i+=2 ) {
          $oTpl->SetVar( "ID", $LOV[$i] );
	  $oTpl->SetVar( "Value", $LOV[$i+1] );
          if ( $LOV[$i] eq $fldis_recommended ) { 
	    $oTpl->SetVar( "Selected", "SELECTED" ) 
	  } else { 
	    $oTpl->SetVar( "Selected", "" )
	  }
          $oTpl->Parse( "LBis_recommended", "True" );
        }
      }
  
  $oTpl->Parse( "FormSearch", "False" );
}



sub Items_Show {

  my ( $sOrder, $iSort, $iSorted, $sDirection, $sSortParams, $iPage );
  my $sWhere = "";
  my $HasParam = 0;
  my $sOrder = "";
  my $sSQL = "";



  $oTpl->SetVar( "TransitParams", "category_id=" . ToURL(GetParam("category_id")) . "&is_recommended=" . ToURL(GetParam("is_recommended")) . "&" );
  $oTpl->SetVar( "FormParams", "category_id=" . ToURL(GetParam("category_id")) . "&is_recommended=" . ToURL(GetParam("is_recommended")) . "&");
# Build WHERE statement

# Check category_id parameter and create a valid sql for where clause
  
  my $pcategory_id = GetParam("category_id");
  if ( $pcategory_id ne "" ) { $pcategory_id = int($pcategory_id) } else { $pcategory_id = "" }
  if ( $pcategory_id ne "" ) {
	$HasParam = 1;
    $sWhere = $sWhere . "i.category_id=" . $pcategory_id
  }
  
# Check is_recommended parameter and create a valid sql for where clause
  
  my $pis_recommended = GetParam("is_recommended");
  if ( $pis_recommended ne "" ) { $pis_recommended = int($pis_recommended) } else { $pis_recommended = "" }
  if ( $pis_recommended ne "" ) {
    if ( $sWhere ne "" ) { $sWhere = $sWhere . " and " }
	$HasParam = 1;
    $sWhere = $sWhere . "i.is_recommended=" . $pis_recommended
  }
  
  if ( $HasParam ) { $sWhere = " AND (" . $sWhere . ")" }
  # Build ORDER statement
  $iSort = GetParam("FormItems_Sorting");
  $iSorted = GetParam("FormItems_Sorted");
  $sDirection = "";
  if ( $iSort eq "" ) {
    $oTpl->SetVar( "Form_Sorting", "" );
  } else {
    if ( $iSort eq $iSorted ) { 
      $oTpl->SetVar( "Form_Sorting", "" );
      $sDirection = " DESC";
      $sSortParams = "FormItems_Sorting=" . $iSort . "&FormItems_Sorted=" . $iSort . "&";
    } else {
      $oTpl->SetVar( "Form_Sorting", $iSort );
      $sDirection = " ASC";
      $sSortParams = "FormItems_Sorting=" . $iSort . "&FormItems_Sorted=" . "&"
    }
    
    if ( $iSort == 1) { $sOrder = " order by i.name" . $sDirection }
    if ( $iSort == 2) { $sOrder = " order by i.author" . $sDirection }
    if ( $iSort == 3) { $sOrder = " order by i.price" . $sDirection }
    if ( $iSort == 4) { $sOrder = " order by c.name" . $sDirection }
    if ( $iSort == 5) { $sOrder = " order by i.is_recommended" . $sDirection }
  }

  # Build full SQL statement
  
  my $sSQL = "select i.author as i_author, " . "i.category_id as i_category_id, " . "i.is_recommended as i_is_recommended, " . "i.item_id as i_item_id, " . "i.name as i_name, " . "i.price as i_price, " . "c.category_id as c_category_id, " . "c.name as c_name " . " from items i, categories as c" . " where c.category_id=i.category_id  ";

  $sSQL = $sSQL . $sWhere . $sOrder;
  $oTpl->SetVar( "FormAction", "BookMaint.cgi" );
  $oTpl->SetVar( "SortParams", $sSortParams );
  
  # Select current page
  $iPage = GetParam("FormItems_Page");
  if ( $iPage eq "" ) { $iPage = 1 }
  $RecordsPerPage = 20;
  # Open recordset
  my @db_rs = openrs( $sSQL, $iPage ); 
  if ( $#db_rs == -1 ) { 
  # Recordset is empty
    $oTpl->SetVar( "DListItems", "" );
    $oTpl->Parse( "ItemsNoRecords", "False" );
    $oTpl->SetVar( "ItemsScroller", "" );
    $oTpl->Parse( "FormItems", "False" );
    return 0
  }


  my @ais_recommended = split /;/, "0;No;1;Yes";

  # Show main table based on recordset
  foreach my $ref_db_record ( @db_rs ) {
    
    my $fldname = GetValue($ref_db_record, "i_name");
    my $fldauthor = GetValue($ref_db_record, "i_author");
    my $fldprice = GetValue($ref_db_record, "i_price");
    my $fldcategory_id = GetValue($ref_db_record, "c_name");
    my $fldis_recommended = GetValue($ref_db_record, "i_is_recommended");
    my $fldField1= "Edit";

      $oTpl->SetVar( "Field1", ToHTML($fldField1) );
      $oTpl->SetVar( "Field1_URLLink", "BookMaint.cgi");
      $oTpl->SetVar( "Prm_item_id", ToURL(GetValue($ref_db_record, "i_item_id"))); 
      $oTpl->SetVar( "name", ToHTML($fldname));
      $oTpl->SetVar( "author", ToHTML($fldauthor));
      $oTpl->SetVar( "price", ToHTML($fldprice));
      $oTpl->SetVar( "category_id", ToHTML($fldcategory_id));
      $fldis_recommended = getValFromLOV($fldis_recommended, @ais_recommended);
      $oTpl->SetVar( "is_recommended", ToHTML($fldis_recommended));

    $oTpl->Parse( "DListItems", "True" );
    
  }


  # Parse scroller
  if ( $is_last_page and $iPage == 1 ) {
    $oTpl->SetVar( "ItemsScroller", "" );
  } else {
    if ( $is_last_page ) {
      $oTpl->SetVar( "ItemsScrollerNextSwitch", "_" );
    } else {
      $oTpl->SetVar( "NextPage", ($iPage + 1) );
      $oTpl->SetVar( "ItemsScrollerNextSwitch", "" );
    }
    if ( $iPage == 1 ) {
      $oTpl->SetVar( "ItemsScrollerPrevSwitch", "_" );
    } else {
      $oTpl->SetVar( "PrevPage", ($iPage - 1) );
      $oTpl->SetVar( "ItemsScrollerPrevSwitch", "" );
    }
    $oTpl->SetVar( "ItemsCurrentPage", $iPage );
    $oTpl->Parse( "ItemsScroller", "False" );
  }

  $oTpl->SetVar( "ItemsNoRecords", "" );
  $oTpl->Parse( "FormItems", "False" );
  
}