#!\Perl\bin\perl.exe
#
# Filename: CategoriesRecord.cgi
# Generated with CodeCharge  1.1.20
# Perl pattern build 05/23/2001
#

use Common;
use TextTemplate;
use strict "vars";

use Header;
use Footer;

StartSession();
%cgi_params = get_form_parameters();

my $sFileName = "CategoriesRecord.cgi";
my $sTemplateFileName = "CategoriesRecord.html";



CheckSecurity(2);


my $sCategoriesErr;
$dbh = DBI->connect( $strConn, $username, $password, { PrintError => 0, RaiseError => 0 } );


$oTpl->LoadTemplate( $sAppPath . $sTemplateFileName, "main" );

$oTpl->LoadTemplate( $sHeaderFileName, "Header" );
$oTpl->LoadTemplate( $sFooterFileName, "Footer" );
$oTpl->SetVar( "FileName", $sFileName );



my $sAction = GetParam("FormAction");
my $sForm = GetParam("FormName");


  if ( $sForm eq "Categories" ) {
    CategoriesAction( $sAction ) }

#Show form content

Menu_Show();
Footer_Show();
Categories_Show();
$oTpl->Parse( "Header", "False" );
$oTpl->Parse( "Footer", "False" );
$oTpl->Parse( "main", "False" );

print $page_header;
print "Content-type: text/html\n\n";
print $oTpl->PrintVar("main");

exit 0;




sub CategoriesAction {
  my $sAction = shift;

  my $sParams = "";
  my $sWhere = "";
  my $bErr = "";
  my $sSQL = "";
  my $sRes = "";

  
  my $sActionFileName = "CategoriesGrid.cgi";
  
  if ( $sAction eq "cancel" ) { http_redirect( $sActionFileName ) }
  # Create WHERE statement
  if ( $sAction eq "update" or $sAction eq "delete" ) {
    my $pPKcategory_id = GetParam("PK_category_id");
    if ( ($pPKcategory_id eq "")) { return 0; }
    $sWhere = "category_id=" . ToSQL($pPKcategory_id, "Number");
  }

  # Load all form fields into variables

  my $fldname = GetParam("name");
  # Validate fields
  if ( $sAction eq "insert" or $sAction eq "update" ) {
    if ( $fldname eq "" ) {
      $sCategoriesErr = $sCategoriesErr . "The value in field Name is required.<br>"
    }
    if ( length($sCategoriesErr) > 0 ) {
      return 0;
    }
  }


# Create SQL statement

    if ( $sAction eq "insert" ) {      
      
      $sSQL = "insert into categories (" . 
          "name)" . 
          " values (" . 
          ToSQL($fldname, "Text") . ")"
}
      
    if ( $sAction eq "update" ) {
        $sSQL = "update categories set " .
        "name=" . ToSQL($fldname, "Text");
        $sSQL = $sSQL . " where " . $sWhere
    }
    
    if ( $sAction eq "delete" ) {
        $sSQL = "delete from categories where " . $sWhere
    }
    
  if ( length($sCategoriesErr) > 0 ) { return 0 }
  # Execute SQL statement
  exec_sql($sSQL);
  $sCategoriesErr = ProceedError();
  if ( length( $sCategoriesErr ) > 0 ) { return 0 }

  http_redirect( $sActionFileName);
  
}


sub Categories_Show {
  my $pcategory_id;

  my $pcategory_id;
  my $sWhere = "";
  
  my $bPK = "True";
  my $fldcategory_id;
  my $fldname;
  my $fldcategory_id;
  my $pcategory_id;

  my $sOrder;

  if ( $sCategoriesErr eq "" ) {
    # Load primary key and form parameters
    $fldcategory_id = GetParam("category_id");
    $pcategory_id = GetParam("category_id");
    $oTpl->SetVar( "CategoriesError", "" );
  } else {
    # Load primary key, form parameters and form fields
    $fldcategory_id = GetParam("category_id");
    $fldname = GetParam("name");
    $pcategory_id = GetParam("PK_category_id");
    $oTpl->SetVar( "sCategoriesErr", $sCategoriesErr );
    $oTpl->Parse( "CategoriesError", "False" );
  }

  
  if ( ($pcategory_id eq "")) { $bPK = ""; }
    
  $sWhere = $sWhere . "category_id=" . ToSQL($pcategory_id, "Number");
  $oTpl->SetVar( "PK_category_id", $pcategory_id );

  my $sSQL = "select * from categories where " . $sWhere;
  my $ref_db_record;


  if ( $bPK and !($sAction eq "insert" and $sForm eq "Categories") ) {
      # Open recordset
      my @db_rs = openrs($sSQL);
      $ref_db_record = $db_rs[0];
    
    $fldcategory_id = GetValue($ref_db_record, "category_id");
    if ( $sCategoriesErr eq "" ) {
      # Load data from recordset when form displayed first time
      $fldname = GetValue($ref_db_record, "name");
    }
    $oTpl->SetVar( "CategoriesInsert", "" );
    $oTpl->Parse( "CategoriesEdit", "False" );
  } else {
    if ( $sCategoriesErr eq "" ) {
      $fldcategory_id = ToHTML(GetParam("category_id"));
    }
    $oTpl->SetVar( "CategoriesEdit", "" );
    $oTpl->Parse( "CategoriesInsert", "False" );
  }
  $oTpl->Parse( "CategoriesCancel", "False" );
  # Show form field
  
      $oTpl->SetVar( "category_id", ToHTML($fldcategory_id));
      $oTpl->SetVar( "name", ToHTML($fldname));
  $oTpl->Parse( "FormCategories", "False" );
  

}