#!\Perl\bin\perl.exe
#
# Filename: MyInfo.cgi
# Generated with CodeCharge  1.1.20
# Perl pattern build 05/23/2001
#

use Common;
use TextTemplate;
use strict "vars";

use Header;
use Footer;

StartSession();
%cgi_params = get_form_parameters();

my $sFileName = "MyInfo.cgi";
my $sTemplateFileName = "MyInfo.html";



CheckSecurity(1);


my $sFormErr;
$dbh = DBI->connect( $strConn, $username, $password, { PrintError => 0, RaiseError => 0 } );


$oTpl->LoadTemplate( $sAppPath . $sTemplateFileName, "main" );

$oTpl->LoadTemplate( $sHeaderFileName, "Header" );
$oTpl->LoadTemplate( $sFooterFileName, "Footer" );
$oTpl->SetVar( "FileName", $sFileName );



my $sAction = GetParam("FormAction");
my $sForm = GetParam("FormName");


  if ( $sForm eq "Form" ) {
    FormAction( $sAction ) }

#Show form content

Menu_Show();
Footer_Show();
Form_Show();
$oTpl->Parse( "Header", "False" );
$oTpl->Parse( "Footer", "False" );
$oTpl->Parse( "main", "False" );

print $page_header;
print "Content-type: text/html\n\n";
print $oTpl->PrintVar("main");

exit 0;




sub FormAction {
  my $sAction = shift;

  my $sParams = "";
  my $sWhere = "";
  my $bErr = "";
  my $sSQL = "";
  my $sRes = "";

  
  my $sActionFileName = "ShoppingCart.cgi";
  
  if ( $sAction eq "cancel" ) { http_redirect( $sActionFileName ) }
  # Create WHERE statement
  if ( $sAction eq "update" or $sAction eq "delete" ) {
    my $pPKmember_id = GetParam("PK_member_id");
    if ( ($pPKmember_id eq "")) { return 0; }
    $sWhere = "member_id=" . ToSQL($pPKmember_id, "Number");
  }

  # Load all form fields into variables

  my $fldUserID = GetSessionVar("UserID");
  my $fldmember_password = GetParam("member_password");
  my $fldname = GetParam("name");
  my $fldlast_name = GetParam("last_name");
  my $fldemail = GetParam("email");
  my $fldaddress = GetParam("address");
  my $fldphone = GetParam("phone");
  my $fldnotes = GetParam("notes");
  my $fldcard_type_id = GetParam("card_type_id");
  my $fldcard_number = GetParam("card_number");
  # Validate fields
  if ( $sAction eq "insert" or $sAction eq "update" ) {
    if ( $fldmember_password eq "" ) {
      $sFormErr = $sFormErr . "The value in field Password* is required.<br>"
    }
    if ( $fldname eq "" ) {
      $sFormErr = $sFormErr . "The value in field First Name* is required.<br>"
    }
    if ( $fldlast_name eq "" ) {
      $sFormErr = $sFormErr . "The value in field Last Name* is required.<br>"
    }
    if ( $fldemail eq "" ) {
      $sFormErr = $sFormErr . "The value in field Email* is required.<br>"
    }
    if ( !IsNumeric($fldcard_type_id) ) {
      $sFormErr = $sFormErr . "The value in field Credit Card Type is incorrect.<br>"
    }
    if ( length($sFormErr) > 0 ) {
      return 0;
    }
  }


# Create SQL statement

    if ( $sAction eq "update" ) {
        $sSQL = "update members set " .
        "member_password=" . ToSQL($fldmember_password, "Text") .
        ",first_name=" . ToSQL($fldname, "Text") .
        ",last_name=" . ToSQL($fldlast_name, "Text") .
        ",email=" . ToSQL($fldemail, "Text") .
        ",address=" . ToSQL($fldaddress, "Text") .
        ",phone=" . ToSQL($fldphone, "Text") .
        ",notes=" . ToSQL($fldnotes, "Text") .
        ",card_type_id=" . ToSQL($fldcard_type_id, "Number") .
        ",card_number=" . ToSQL($fldcard_number, "Text");
        $sSQL = $sSQL . " where " . $sWhere
    }
    
  if ( length($sFormErr) > 0 ) { return 0 }
  # Execute SQL statement
  exec_sql($sSQL);
  $sFormErr = ProceedError();
  if ( length( $sFormErr ) > 0 ) { return 0 }

  http_redirect( $sActionFileName);
  
}


sub Form_Show {
  my $pmember_id;

  my $sWhere = "";
  
  my $bPK = "True";
  my $fldmember_id;
  my $fldmember_login;
  my $fldmember_password;
  my $fldname;
  my $fldlast_name;
  my $fldemail;
  my $fldaddress;
  my $fldphone;
  my $fldnotes;
  my $fldcard_type_id;
  my $fldcard_number;
  my $fldUserID;
  my $pmember_id;

  my $sOrder;

  if ( $sFormErr eq "" ) {
    # Load primary key and form parameters
    $oTpl->SetVar( "FormError", "" );
  } else {
    # Load primary key, form parameters and form fields
    $fldmember_id = GetParam("member_id");
    $fldmember_password = GetParam("member_password");
    $fldname = GetParam("name");
    $fldlast_name = GetParam("last_name");
    $fldemail = GetParam("email");
    $fldaddress = GetParam("address");
    $fldphone = GetParam("phone");
    $fldnotes = GetParam("notes");
    $fldcard_type_id = GetParam("card_type_id");
    $fldcard_number = GetParam("card_number");
    $oTpl->SetVar( "sFormErr", $sFormErr );
    $oTpl->Parse( "FormError", "False" );
  }

  
  $pmember_id = GetSessionVar("UserID");
  if ( ($pmember_id eq "")) { $bPK = ""; }
    
  $sWhere = $sWhere . "member_id=" . ToSQL($pmember_id, "Number");
  $oTpl->SetVar( "PK_member_id", $pmember_id );

  my $sSQL = "select * from members where " . $sWhere;
  my $ref_db_record;


  if ( $bPK and !($sAction eq "insert" and $sForm eq "Form") ) {
      # Open recordset
      my @db_rs = openrs($sSQL);
      $ref_db_record = $db_rs[0];
    
    $fldmember_id = GetValue($ref_db_record, "member_id");
    $fldmember_login = GetValue($ref_db_record, "member_login");
    if ( $sFormErr eq "" ) {
      # Load data from recordset when form displayed first time
      $fldmember_password = GetValue($ref_db_record, "member_password");
      $fldname = GetValue($ref_db_record, "first_name");
      $fldlast_name = GetValue($ref_db_record, "last_name");
      $fldemail = GetValue($ref_db_record, "email");
      $fldaddress = GetValue($ref_db_record, "address");
      $fldphone = GetValue($ref_db_record, "phone");
      $fldnotes = GetValue($ref_db_record, "notes");
      $fldcard_type_id = GetValue($ref_db_record, "card_type_id");
      $fldcard_number = GetValue($ref_db_record, "card_number");
    }
    $oTpl->SetVar( "FormDelete", "" );
    $oTpl->SetVar( "FormInsert", "" );
    $oTpl->Parse( "FormEdit", "False" );
  } else {
    if ( $sFormErr eq "" ) {
      $fldmember_id = ToHTML(GetSessionVar("UserID"));
    }
    $oTpl->SetVar( "FormEdit", "" );
    $oTpl->SetVar( "FormInsert", "" );
  }
  $oTpl->Parse( "FormCancel", "False" );
  # Show form field
  
      $oTpl->SetVar( "member_id", ToHTML($fldmember_id));
      $oTpl->SetVar( "member_login", ToHTML($fldmember_login));
      $oTpl->SetVar( "member_password", ToHTML($fldmember_password));
      $oTpl->SetVar( "name", ToHTML($fldname));
      $oTpl->SetVar( "last_name", ToHTML($fldlast_name));
      $oTpl->SetVar( "email", ToHTML($fldemail));
      $oTpl->SetVar( "address", ToHTML($fldaddress));
      $oTpl->SetVar( "phone", ToHTML($fldphone));
      $oTpl->SetVar( "notes", ToHTML($fldnotes));
      $oTpl->SetVar( "LBcard_type_id", "" );
      $oTpl->SetVar( "ID", "" );
      $oTpl->SetVar( "Value", "" );
      $oTpl->Parse( "LBcard_type_id", "True" );
      my @card_type_id = openrs_arr( "select card_type_id, name from card_types order by 2" );
      foreach my $card_type_id ( @card_type_id ) {
        $oTpl->SetVar( "ID", $card_type_id->[0] );
	$oTpl->SetVar( "Value", $card_type_id->[1] );
        if ( GetValue($card_type_id, 0) eq $fldcard_type_id) { $oTpl->SetVar( "Selected", "SELECTED" ) } else { $oTpl->SetVar( "Selected", "" ) }
        $oTpl->Parse( "LBcard_type_id", "True" );
      }
        
      $oTpl->SetVar( "card_number", ToHTML($fldcard_number));
  $oTpl->Parse( "FormForm", "False" );
  

}