#!\Perl\bin\perl.exe
#
# Filename: Registration.cgi
# Generated with CodeCharge  1.1.20
# Perl pattern build 05/23/2001
#

use Common;
use TextTemplate;
use strict "vars";

use Header;
use Footer;

StartSession();
%cgi_params = get_form_parameters();

my $sFileName = "Registration.cgi";
my $sTemplateFileName = "Registration.html";




my $sRegErr;
$dbh = DBI->connect( $strConn, $username, $password, { PrintError => 0, RaiseError => 0 } );


$oTpl->LoadTemplate( $sAppPath . $sTemplateFileName, "main" );

$oTpl->LoadTemplate( $sHeaderFileName, "Header" );
$oTpl->LoadTemplate( $sFooterFileName, "Footer" );
$oTpl->SetVar( "FileName", $sFileName );



my $sAction = GetParam("FormAction");
my $sForm = GetParam("FormName");


  if ( $sForm eq "Reg" ) {
    RegAction( $sAction ) }

#Show form content

Menu_Show();
Footer_Show();
Reg_Show();
$oTpl->Parse( "Header", "False" );
$oTpl->Parse( "Footer", "False" );
$oTpl->Parse( "main", "False" );

print $page_header;
print "Content-type: text/html\n\n";
print $oTpl->PrintVar("main");

exit 0;




sub RegAction {
  my $sAction = shift;

  my $sParams = "";
  my $sWhere = "";
  my $bErr = "";
  my $sSQL = "";
  my $sRes = "";

  
  my $sActionFileName = "Default.cgi";
  
  if ( $sAction eq "cancel" ) { http_redirect( $sActionFileName ) }
  # Load all form fields into variables

  my $fldmember_login = GetParam("member_login");
  my $fldmember_password = GetParam("member_password");
  my $fldmember_password2 = GetParam("member_password2");
  my $fldfirst_name = GetParam("first_name");
  my $fldlast_name = GetParam("last_name");
  my $fldemail = GetParam("email");
  my $fldaddress = GetParam("address");
  my $fldphone = GetParam("phone");
  my $fldcard_type_id = GetParam("card_type_id");
  my $fldcard_number = GetParam("card_number");
  # Validate fields
  if ( $sAction eq "insert" or $sAction eq "update" ) {
    if ( $fldmember_login eq "" ) {
      $sRegErr = $sRegErr . "The value in field Login* is required.<br>"
    }
    if ( $fldmember_password eq "" ) {
      $sRegErr = $sRegErr . "The value in field Password* is required.<br>"
    }
    if ( $fldmember_password2 eq "" ) {
      $sRegErr = $sRegErr . "The value in field Confirm Password* is required.<br>"
    }
    if ( $fldfirst_name eq "" ) {
      $sRegErr = $sRegErr . "The value in field First Name* is required.<br>"
    }
    if ( $fldlast_name eq "" ) {
      $sRegErr = $sRegErr . "The value in field Last Name* is required.<br>"
    }
    if ( $fldemail eq "" ) {
      $sRegErr = $sRegErr . "The value in field Email* is required.<br>"
    }
    if ( !IsNumeric($fldcard_type_id) ) {
      $sRegErr = $sRegErr . "The value in field Credit Card Type is incorrect.<br>"
    }
    if ( $fldmember_login ne ""  ) {
      my $iCount = 0;
      if ( $sAction eq "insert" ) {
        $iCount = DLookUp("members", "count(*)", "member_login=" . ToSQL($fldmember_login, "Text"));
      } elsif ( $sAction eq "update" ) {
        $iCount = DLookUp("members", "count(*)", "member_login=" . ToSQL($fldmember_login, "Text") . " and not(" . $sWhere . ")");
      }
      if ( $iCount > 0 ) {
        $sRegErr = $sRegErr . "The value in field Login* is already in database.<br>";
      }
    }
if ( GetParam("member_password")  ne GetParam("member_password2") )  {
  $sRegErr .= chr(13) . "Password and Confirm Password fields don't match";
}
    if ( length($sRegErr) > 0 ) {
      return 0;
    }
  }


# Create SQL statement

    if ( $sAction eq "insert" ) {      
      
      $sSQL = "insert into members (" . 
          "member_login," . 
          "member_password," . 
          "first_name," . 
          "last_name," . 
          "email," . 
          "address," . 
          "phone," . 
          "card_type_id," . 
          "card_number)" . 
          " values (" . 
          ToSQL($fldmember_login, "Text") . "," . 
          ToSQL($fldmember_password, "Text") . "," . 
          ToSQL($fldfirst_name, "Text") . "," . 
          ToSQL($fldlast_name, "Text") . "," . 
          ToSQL($fldemail, "Text") . "," . 
          ToSQL($fldaddress, "Text") . "," . 
          ToSQL($fldphone, "Text") . "," . 
          ToSQL($fldcard_type_id, "Number") . "," . 
          ToSQL($fldcard_number, "Text") . ")"
}
      
  if ( length($sRegErr) > 0 ) { return 0 }
  # Execute SQL statement
  exec_sql($sSQL);
  $sRegErr = ProceedError();
  if ( length( $sRegErr ) > 0 ) { return 0 }

  http_redirect( $sActionFileName);
  
}


sub Reg_Show {
  my $pmember_id;

  my $pmember_id;
  my $sWhere = "";
  
  my $bPK = "True";
  my $fldmember_id;
  my $fldmember_login;
  my $fldmember_password;
  my $fldmember_password2;
  my $fldfirst_name;
  my $fldlast_name;
  my $fldemail;
  my $fldaddress;
  my $fldphone;
  my $fldcard_type_id;
  my $fldcard_number;
  my $pmember_id;

  my $sOrder;

  if ( $sRegErr eq "" ) {
    # Load primary key and form parameters
    $pmember_id = GetParam("member_id");
    $oTpl->SetVar( "RegError", "" );
  } else {
    # Load primary key, form parameters and form fields
    $fldmember_id = GetParam("member_id");
    $fldmember_login = GetParam("member_login");
    $fldmember_password = GetParam("member_password");
    $fldfirst_name = GetParam("first_name");
    $fldlast_name = GetParam("last_name");
    $fldemail = GetParam("email");
    $fldaddress = GetParam("address");
    $fldphone = GetParam("phone");
    $fldcard_type_id = GetParam("card_type_id");
    $fldcard_number = GetParam("card_number");
    $pmember_id = GetParam("PK_member_id");
    $oTpl->SetVar( "sRegErr", $sRegErr );
    $oTpl->Parse( "RegError", "False" );
  }

  
  $fldmember_password2 = GetParam("member_password2");
  if ( ($pmember_id eq "")) { $bPK = ""; }
    
  $sWhere = $sWhere . "member_id=" . ToSQL($pmember_id, "Number");
  $oTpl->SetVar( "PK_member_id", $pmember_id );

  my $sSQL = "select * from members where " . $sWhere;
  my $ref_db_record;


  if ( $bPK and !($sAction eq "insert" and $sForm eq "Reg") ) {
      # Open recordset
      my @db_rs = openrs($sSQL);
      $ref_db_record = $db_rs[0];
    
    $fldmember_id = GetValue($ref_db_record, "member_id");
    if ( $sRegErr eq "" ) {
      # Load data from recordset when form displayed first time
      $fldmember_login = GetValue($ref_db_record, "member_login");
      $fldmember_password = GetValue($ref_db_record, "member_password");
      $fldfirst_name = GetValue($ref_db_record, "first_name");
      $fldlast_name = GetValue($ref_db_record, "last_name");
      $fldemail = GetValue($ref_db_record, "email");
      $fldaddress = GetValue($ref_db_record, "address");
      $fldphone = GetValue($ref_db_record, "phone");
      $fldcard_type_id = GetValue($ref_db_record, "card_type_id");
      $fldcard_number = GetValue($ref_db_record, "card_number");
    }
    $oTpl->SetVar( "RegDelete", "" );
    $oTpl->SetVar( "RegUpdate", "" );
    $oTpl->SetVar( "RegInsert", "" );
  } else {
    $oTpl->SetVar( "RegEdit", "" );
    $oTpl->Parse( "RegInsert", "False" );
  }
  $oTpl->Parse( "RegCancel", "False" );
  # Show form field
  
      $oTpl->SetVar( "member_id", ToHTML($fldmember_id));
      $oTpl->SetVar( "member_login", ToHTML($fldmember_login));
      $oTpl->SetVar( "member_password", ToHTML($fldmember_password));
      $oTpl->SetVar( "member_password2", ToHTML($fldmember_password2));
      $oTpl->SetVar( "first_name", ToHTML($fldfirst_name));
      $oTpl->SetVar( "last_name", ToHTML($fldlast_name));
      $oTpl->SetVar( "email", ToHTML($fldemail));
      $oTpl->SetVar( "address", ToHTML($fldaddress));
      $oTpl->SetVar( "phone", ToHTML($fldphone));
      $oTpl->SetVar( "LBcard_type_id", "" );
      $oTpl->SetVar( "ID", "" );
      $oTpl->SetVar( "Value", "" );
      $oTpl->Parse( "LBcard_type_id", "True" );
      my @card_type_id = openrs_arr( "select card_type_id, name from card_types order by 2" );
      foreach my $card_type_id ( @card_type_id ) {
        $oTpl->SetVar( "ID", $card_type_id->[0] );
	$oTpl->SetVar( "Value", $card_type_id->[1] );
        if ( GetValue($card_type_id, 0) eq $fldcard_type_id) { $oTpl->SetVar( "Selected", "SELECTED" ) } else { $oTpl->SetVar( "Selected", "" ) }
        $oTpl->Parse( "LBcard_type_id", "True" );
      }
        
      $oTpl->SetVar( "card_number", ToHTML($fldcard_number));
  $oTpl->Parse( "FormReg", "False" );
  

}