#!\Perl\bin\perl.exe
#
# Filename: ShoppingCart.cgi
# Generated with CodeCharge  1.1.20
# Perl pattern build 05/23/2001
#

use Common;
use TextTemplate;
use strict "vars";

use Header;
use Footer;

StartSession();
%cgi_params = get_form_parameters();

my $sFileName = "ShoppingCart.cgi";
my $sTemplateFileName = "ShoppingCart.html";



CheckSecurity(1);


my $sMemberErr;
$dbh = DBI->connect( $strConn, $username, $password, { PrintError => 0, RaiseError => 0 } );


$oTpl->LoadTemplate( $sAppPath . $sTemplateFileName, "main" );

$oTpl->LoadTemplate( $sHeaderFileName, "Header" );
$oTpl->LoadTemplate( $sFooterFileName, "Footer" );
$oTpl->SetVar( "FileName", $sFileName );



my $sAction = GetParam("FormAction");
my $sForm = GetParam("FormName");


  if ( $sForm eq "Member" ) {
    MemberAction( $sAction ) }

#Show form content

Menu_Show();
Footer_Show();
Items_Show();
Total_Show();
Member_Show();
$oTpl->Parse( "Header", "False" );
$oTpl->Parse( "Footer", "False" );
$oTpl->Parse( "main", "False" );

print $page_header;
print "Content-type: text/html\n\n";
print $oTpl->PrintVar("main");

exit 0;




sub Items_Show {

  my ( $sOrder, $iSort, $iSorted, $sDirection, $sSortParams, $iPage );
  my $sWhere = "";
  my $HasParam = 0;
  my $sOrder = "";
  my $sSQL = "";



  $oTpl->SetVar( "TransitParams", "" );
  $oTpl->SetVar( "FormParams", "" );  
  my $bReq = "1";
# Build WHERE statement

# Check UserID parameter and create a valid sql for where clause
  
  my $pUserID = GetSessionVar("UserID");
  if ( $pUserID ne "" ) { $pUserID = int($pUserID) } else { $pUserID = "" }
  if ( $pUserID ne "" ) {
	$HasParam = 1;
    $sWhere = $sWhere . "member_id=" . $pUserID
  } else {
    $bReq = ""
  }
  
  if ( $HasParam ) { $sWhere = " AND (" . $sWhere . ")" }

  # Build full SQL statement
  
  my $sSQL = "SELECT order_id, name, price, quantity, member_id, quantity*price as sub_total FROM items, orders WHERE orders.item_id=items.item_id" . $sWhere . " ORDER BY order_id";

  if ( !$bReq ) {
    $oTpl->SetVar( "DListItems", "" );
    $oTpl->Parse( "ItemsNoRecords", "False" );

    $oTpl->Parse( "FormItems", "False" );
    return 0
  }

  # Open recordset
  my @db_rs = openrs( $sSQL, $iPage ); 
  if ( $#db_rs == -1 ) { 
  # Recordset is empty
    $oTpl->SetVar( "DListItems", "" );
    $oTpl->Parse( "ItemsNoRecords", "False" );
    $oTpl->Parse( "FormItems", "False" );
    return 0
  }



  # Show main table based on recordset
  foreach my $ref_db_record ( @db_rs ) {
    
    my $fldorder_id = GetValue($ref_db_record, "order_id");
    my $flditem_id = GetValue($ref_db_record, "name");
    my $fldprice = GetValue($ref_db_record, "price");
    my $fldquantity = GetValue($ref_db_record, "quantity");
    my $fldsub_total = GetValue($ref_db_record, "sub_total");
    my $fldField1= "Details";

      $oTpl->SetVar( "Field1", ToHTML($fldField1) );
      $oTpl->SetVar( "Field1_URLLink", "ShoppingCartRecord.cgi");
      $oTpl->SetVar( "Prm_order_id", ToURL(GetValue($ref_db_record, "order_id"))); 
      $oTpl->SetVar( "order_id", ToHTML($fldorder_id));
      $oTpl->SetVar( "item_id", ToHTML($flditem_id));
      $oTpl->SetVar( "price", ToHTML($fldprice));
      $oTpl->SetVar( "quantity", ToHTML($fldquantity));
      $oTpl->SetVar( "sub_total", ToHTML($fldsub_total));

    $oTpl->Parse( "DListItems", "True" );
    
  }


  $oTpl->SetVar( "ItemsNoRecords", "" );
  $oTpl->Parse( "FormItems", "False" );
  
}



sub Total_Show {

  my ( $sOrder, $iSort, $iSorted, $sDirection, $sSortParams, $iPage );
  my $sWhere = "";
  my $HasParam = 0;
  my $sOrder = "";
  my $sSQL = "";



  $oTpl->SetVar( "TransitParams", "" );
  $oTpl->SetVar( "FormParams", "" );  
  my $bReq = "1";
# Build WHERE statement

# Check UserID parameter and create a valid sql for where clause
  
  my $pUserID = GetSessionVar("UserID");
  if ( $pUserID ne "" ) { $pUserID = int($pUserID) } else { $pUserID = "" }
  if ( $pUserID ne "" ) {
	$HasParam = 1;
    $sWhere = $sWhere . "member_id=" . $pUserID
  } else {
    $bReq = ""
  }
  
  if ( $HasParam ) { $sWhere = " AND (" . $sWhere . ")" }

  # Build full SQL statement
  
  my $sSQL = "SELECT member_id, sum(quantity*price) as sub_total FROM items, orders WHERE orders.item_id=items.item_id" . $sWhere . " GROUP BY member_id";

  if ( !$bReq ) {
    $oTpl->SetVar( "DListTotal", "" );
    $oTpl->Parse( "TotalNoRecords", "False" );

    $oTpl->Parse( "FormTotal", "False" );
    return 0
  }

  # Open recordset
  my @db_rs = openrs( $sSQL, $iPage ); 
  if ( $#db_rs == -1 ) { 
  # Recordset is empty
    $oTpl->SetVar( "DListTotal", "" );
    $oTpl->Parse( "TotalNoRecords", "False" );
    $oTpl->Parse( "FormTotal", "False" );
    return 0
  }



  # Show main table based on recordset
  foreach my $ref_db_record ( @db_rs ) {
    
    my $fldsub_total = GetValue($ref_db_record, "sub_total");

      $oTpl->SetVar( "sub_total", ToHTML($fldsub_total));

    $oTpl->Parse( "DListTotal", "True" );
    
  }


  $oTpl->SetVar( "TotalNoRecords", "" );
  $oTpl->Parse( "FormTotal", "False" );
  
}



sub MemberAction {
  my $sAction = shift;

  my $sParams = "";
  my $sWhere = "";
  my $bErr = "";
  my $sSQL = "";
  my $sRes = "";

  
  my $sActionFileName = "AdminMenu.cgi";
  
  $sParams = "?";
  $sParams = $sParams . "UserID=" . ToURL(GetParam("Trn_UserID"));
  # Load all form fields into variables

  my $fldUserID = GetSessionVar("UserID");

# Create SQL statement

  if ( length($sMemberErr) > 0 ) { return 0 }
  # Execute SQL statement
  exec_sql($sSQL);
  $sMemberErr = ProceedError();
  if ( length( $sMemberErr ) > 0 ) { return 0 }

  http_redirect( $sActionFileName . $sParams );
  
}


sub Member_Show {
  my $pmember_id;

  my $sWhere = "";
  
  my $bPK = "True";
  my $fldmember_id;
  my $fldmember_login;
  my $fldname;
  my $fldlast_name;
  my $fldaddress;
  my $fldemail;
  my $fldphone;
  my $fldUserID;
  my $pmember_id;

  my $sOrder;

  if ( $sMemberErr eq "" ) {
    # Load primary key and form parameters
    $oTpl->SetVar( "MemberError", "" );
  } else {
    # Load primary key, form parameters and form fields
    $fldmember_id = GetParam("member_id");
    $oTpl->SetVar( "sMemberErr", $sMemberErr );
    $oTpl->Parse( "MemberError", "False" );
  }

  
  $pmember_id = GetSessionVar("UserID");
  if ( ($pmember_id eq "")) { $bPK = ""; }
    
  $sWhere = $sWhere . "member_id=" . ToSQL($pmember_id, "Number");
  $oTpl->SetVar( "PK_member_id", $pmember_id );

  my $sSQL = "select * from members where " . $sWhere;
  my $ref_db_record;


  if ( $bPK and !($sAction eq "insert" and $sForm eq "Member") ) {
      # Open recordset
      my @db_rs = openrs($sSQL);
      $ref_db_record = $db_rs[0];
    
    $fldmember_id = GetValue($ref_db_record, "member_id");
    $fldmember_login = GetValue($ref_db_record, "member_login");
    $fldname = GetValue($ref_db_record, "first_name");
    $fldlast_name = GetValue($ref_db_record, "last_name");
    $fldaddress = GetValue($ref_db_record, "address");
    $fldemail = GetValue($ref_db_record, "email");
    $fldphone = GetValue($ref_db_record, "phone");
    $oTpl->SetVar( "MemberDelete", "" );
    $oTpl->SetVar( "MemberUpdate", "" );
    $oTpl->SetVar( "MemberInsert", "" );
  } else {
    if ( $sMemberErr eq "" ) {
      $fldmember_id = ToHTML(GetSessionVar("UserID"));
    }
    $oTpl->SetVar( "MemberEdit", "" );
    $oTpl->SetVar( "MemberInsert", "" );
  }
  $oTpl->SetVar( "MemberCancel", "" );
  # Show form field
  
      $oTpl->SetVar( "member_id", ToHTML($fldmember_id));
      $oTpl->SetVar( "member_login", ToHTML($fldmember_login) );
      $oTpl->SetVar( "member_login_URLLink", "MyInfo.cgi");
      $oTpl->SetVar( "name", ToHTML($fldname));
      $oTpl->SetVar( "last_name", ToHTML($fldlast_name));
      $oTpl->SetVar( "address", ToHTML($fldaddress));
      $oTpl->SetVar( "email", ToHTML($fldemail));
      $oTpl->SetVar( "phone", ToHTML($fldphone));
  $oTpl->Parse( "FormMember", "False" );
  

}