#!\Perl\bin\perl.exe
#
# Filename: ShoppingCartRecord.cgi
# Generated with CodeCharge  1.1.20
# Perl pattern build 05/23/2001
#

use Common;
use TextTemplate;
use strict "vars";

use Header;
use Footer;

StartSession();
%cgi_params = get_form_parameters();

my $sFileName = "ShoppingCartRecord.cgi";
my $sTemplateFileName = "ShoppingCartRecord.html";



CheckSecurity(1);


my $sShoppingCartRecordErr;
$dbh = DBI->connect( $strConn, $username, $password, { PrintError => 0, RaiseError => 0 } );


$oTpl->LoadTemplate( $sAppPath . $sTemplateFileName, "main" );

$oTpl->LoadTemplate( $sHeaderFileName, "Header" );
$oTpl->LoadTemplate( $sFooterFileName, "Footer" );
$oTpl->SetVar( "FileName", $sFileName );



my $sAction = GetParam("FormAction");
my $sForm = GetParam("FormName");


  if ( $sForm eq "ShoppingCartRecord" ) {
    ShoppingCartRecordAction( $sAction ) }

#Show form content

Menu_Show();
Footer_Show();
ShoppingCartRecord_Show();
$oTpl->Parse( "Header", "False" );
$oTpl->Parse( "Footer", "False" );
$oTpl->Parse( "main", "False" );

print $page_header;
print "Content-type: text/html\n\n";
print $oTpl->PrintVar("main");

exit 0;




sub ShoppingCartRecordAction {
  my $sAction = shift;

  my $sParams = "";
  my $sWhere = "";
  my $bErr = "";
  my $sSQL = "";
  my $sRes = "";

  
  my $sActionFileName = "ShoppingCart.cgi";
  
  if ( $sAction eq "cancel" ) { http_redirect( $sActionFileName ) }
  # Create WHERE statement
  if ( $sAction eq "update" or $sAction eq "delete" ) {
    my $pPKorder_id = GetParam("PK_order_id");
    if ( ($pPKorder_id eq "")) { return 0; }
    $sWhere = "order_id=" . ToSQL($pPKorder_id, "Number");
  }

  # Load all form fields into variables

  my $fldUserID = GetSessionVar("UserID");
  my $fldmember_id = GetParam("member_id");
  my $fldquantity = GetParam("quantity");
  # Validate fields
  if ( $sAction eq "insert" or $sAction eq "update" ) {
    if ( $fldquantity eq "" ) {
      $sShoppingCartRecordErr = $sShoppingCartRecordErr . "The value in field Quantity is required.<br>"
    }
    if ( !IsNumeric($fldmember_id) ) {
      $sShoppingCartRecordErr = $sShoppingCartRecordErr . "The value in field member_id is incorrect.<br>"
    }
    if ( !IsNumeric($fldquantity) ) {
      $sShoppingCartRecordErr = $sShoppingCartRecordErr . "The value in field Quantity is incorrect.<br>"
    }
    if ( length($sShoppingCartRecordErr) > 0 ) {
      return 0;
    }
  }


# Create SQL statement

    if ( $sAction eq "update" ) {
        $sSQL = "update orders set " .
        "member_id=" . ToSQL($fldmember_id, "Number") .
        ",quantity=" . ToSQL($fldquantity, "Number");
        $sSQL = $sSQL . " where " . $sWhere
    }
    
    if ( $sAction eq "delete" ) {
        $sSQL = "delete from orders where " . $sWhere
    }
    
  if ( length($sShoppingCartRecordErr) > 0 ) { return 0 }
  # Execute SQL statement
  exec_sql($sSQL);
  $sShoppingCartRecordErr = ProceedError();
  if ( length( $sShoppingCartRecordErr ) > 0 ) { return 0 }

  http_redirect( $sActionFileName);
  
}


sub ShoppingCartRecord_Show {
  my $porder_id;

  my $porder_id;
  my $sWhere = "";
  
  my $bPK = "True";
  my $fldorder_id;
  my $fldmember_id;
  my $flditem_id;
  my $fldquantity;
  my $fldUserID;
  my $porder_id;

  my $sOrder;

  if ( $sShoppingCartRecordErr eq "" ) {
    # Load primary key and form parameters
    $porder_id = GetParam("order_id");
    $oTpl->SetVar( "ShoppingCartRecordError", "" );
  } else {
    # Load primary key, form parameters and form fields
    $fldorder_id = GetParam("order_id");
    $fldmember_id = GetParam("member_id");
    $fldquantity = GetParam("quantity");
    $porder_id = GetParam("PK_order_id");
    $oTpl->SetVar( "sShoppingCartRecordErr", $sShoppingCartRecordErr );
    $oTpl->Parse( "ShoppingCartRecordError", "False" );
  }

  
  if ( ($porder_id eq "")) { $bPK = ""; }
    
  $sWhere = $sWhere . "order_id=" . ToSQL($porder_id, "Number");
  $oTpl->SetVar( "PK_order_id", $porder_id );

  my $sSQL = "select * from orders where " . $sWhere;
  my $ref_db_record;


  if ( $bPK and !($sAction eq "insert" and $sForm eq "ShoppingCartRecord") ) {
      # Open recordset
      my @db_rs = openrs($sSQL);
      $ref_db_record = $db_rs[0];
    
    $fldorder_id = GetValue($ref_db_record, "order_id");
    $fldmember_id = GetValue($ref_db_record, "member_id");
    $flditem_id = GetValue($ref_db_record, "item_id");
    if ( $sShoppingCartRecordErr eq "" ) {
      # Load data from recordset when form displayed first time
      $fldquantity = GetValue($ref_db_record, "quantity");
    }
    $oTpl->SetVar( "ShoppingCartRecordInsert", "" );
    $oTpl->Parse( "ShoppingCartRecordEdit", "False" );
  } else {
    if ( $sShoppingCartRecordErr eq "" ) {
      $fldmember_id = ToHTML(GetSessionVar("UserID"));
    }
    $oTpl->SetVar( "ShoppingCartRecordEdit", "" );
    $oTpl->SetVar( "ShoppingCartRecordInsert", "" );
  }
  $oTpl->Parse( "ShoppingCartRecordCancel", "False" );
  $flditem_id = DLookUp("items", "name", "item_id=" . ToSQL($flditem_id, "Number"));
  # Set lookup fields
  # Show form field
  
      $oTpl->SetVar( "order_id", ToHTML($fldorder_id));
      $oTpl->SetVar( "member_id", ToHTML($fldmember_id));
      $oTpl->SetVar( "item_id", ToHTML($flditem_id));
      $oTpl->SetVar( "quantity", ToHTML($fldquantity));
  $oTpl->Parse( "FormShoppingCartRecord", "False" );
  

}